

#    MIDAS Access Client  for the  XPGRISAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global XPGRISAccessServerHost XPGRISAccessServerPort

if {[info exists XPGRISAccessServerHost] == 0} then {set XPGRISAccessServerHost localhost}
if {[info exists XPGRISAccessServerPort] == 0} then {set XPGRISAccessServerPort 8015}


variable uri "urn:XPGRISAccessServer"
variable proxy "http://$XPGRISAccessServerHost:$XPGRISAccessServerPort/XPGRISAccessServer"

set XPGRISAccessServerTimeOut 10000

SOAP::create XPGRISAccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name  AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create XPGRISAccessClient__Get -proxy $proxy -uri $uri -timeout $XPGRISAccessServerTimeOut \
     -name Get \
     -params {Address int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XPGRISAccessClient__Set -proxy $proxy -uri $uri -timeout $XPGRISAccessServerTimeOut \
     -name Set \
     -params {Address int Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XPGRISAccessClient__SetBitRegister -proxy $proxy -uri $uri -timeout $XPGRISAccessServerTimeOut \
     -name SetBitRegister \
     -params {Address int Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply



package provide XPGRISAccessClient 1.0
