

#    MIDAS Access Client  for the  XR3BASICAccess service


package require MIDASAccessClient    ;#   load default support procedures

global MIDAS_XR3BASICAccessClient_Exists
set MIDAS_XR3BASICAccessClient_Exists 1

global XR3BASICAccessServerHost XR3BASICAccessServerPort

if {[info exists XR3BASICAccessServerHost] == 0} then {set XR3BASICAccessServerHost localhost}
if {[info exists XR3BASICAccessServerPort] == 0} then {set XR3BASICAccessServerPort 8015}


variable uri "urn:XR3BASICAccessServer"
variable proxy "http://$XR3BASICAccessServerHost:$XR3BASICAccessServerPort/XR3BASICAccessServer"

set XR3BASICAccessServerTimeOut 10000

proc XR3BASICAccessClient_Configure {} {
   global XR3BASICAccessServerHost XR3BASICAccessServerPort
   variable proxy

   set proxy "http://$XR3BASICAccessServerHost:$XR3BASICAccessServerPort/XR3BASICAccessServer"

   foreach method [info procs XR3BASICAccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create XR3BASICAccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name  AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create XR3BASICAccessClient__Get -proxy $proxy -uri $uri -timeout $XR3BASICAccessServerTimeOut \
     -name Get \
     -params {Address int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XR3BASICAccessClient__Set -proxy $proxy -uri $uri -timeout $XR3BASICAccessServerTimeOut \
     -name Set \
     -params {Address int Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply


package provide XR3BASICAccessClient 1.0
