

#    support for Web Service access  -  provides application specific support

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0


variable SYS_DataAcquisitionCode  0

variable RunControlDelay1 100
variable RunControlDelay2 50
variable RunControlDelay3 500



proc Appdo_Setup {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1
    global MIDAS_DataAcquisitionControlServer_Verbose
    if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "called method Appdo_SetUp with args $args"}

# puts "do_Setup:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_SetUpC} m]
        if {$z != 0} {puts "do_Setup gets $m"}
    }

   set SYS_DataAcquisitionCode 3

# puts "Setup: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_SetUpC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doSetUp} m]            ;#  
     if {$z != 0} {
puts "SetUpC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 0     ;#  state = STOPPED
     }

# puts "SetupC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_Reset {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Reset:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_ResetC} m]
        if {$z != 0} {puts "do_Reset gets $m"}
    }

   set SYS_DataAcquisitionCode 7

# puts "Reset: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_ResetC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doReset} m]       ;# 
     if {$z != 0} {
puts "ResetC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 2     ;#  state = RESET
     }

# puts "ResetC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_Stop {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Stop:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_StopC} m]
        if {$z != 0} {puts "do_Stop gets $m"}
    }

   set SYS_DataAcquisitionCode 5

# puts "Stop: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_StopC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doStop} m]         ;#  
     if {$z != 0} {
puts "StopC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 0     ;#  state = STOPPED
     }

# puts "StopC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_Go {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Go:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_GoC} m]
        if {$z != 0} {puts "do_Go gets $m"}
    }

   set SYS_DataAcquisitionCode 4

# puts "Go: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_GoC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doGo} m]        ;#  
     if {$z != 0} {
puts "GoC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 1     ;#  state = GOING
     }

# puts "GoC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_GetState {args} {
    variable SYS_DataAcquisitionCode

    return $SYS_DataAcquisitionCode
}

proc Appdo_SetOption {args} {
    global errorCode errorInfo
    global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionState MIDAS_DataAcquisitionReason
    global MIDAS_DataAcquisitionError MIDAS_DataAcquisitionInfo
    global MIDAS_DataAcquisitionControlServer_Verbose
    if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "called method Appdo_SetOption with args $args"}

   if {[llength $args] == 1} {set args [first $args]}

   set state [lindex $args 0]
   set opt [lindex $args 1]

   set cmd [first [split $opt =]]
   set vl [second [split $opt =]]

       switch $cmd {
           ReSync {
              switch $vl {
                 All -
                 ALL {set rc [catch {AGATADigitizer::do_ReSyncAllDigitizers} m]}
                 default {set rc [catch {AGATADigitizer::do_ReSyncDigitizer $vl} m]}
              }
              set MIDAS_DataAcquisitionCode $state
           }
           SetUp {
              switch $vl {
                 All -
                 ALL {set rc [catch {AGATADigitizer::do_SetUpAllDigitizers} m]}
                 default {set rc [catch {AGATADigitizer::do_SetUpDigitizer $vl} m]}
              }
              set MIDAS_DataAcquisitionCode $state
           }
           State {
              set MIDAS_DataAcquisitionCode $value
              set rc 0
           }
           default {
              puts "called method executeOption with args $state $opt"
              set MIDAS_DataAcquisitionCode $state
              set rc 0
           }
       }

        if {$rc != 0} {

            puts "OPTION returned with an error\n$m\n$errorCode\n$errorInfo"

            set MIDAS_DataAcquisitionCode 6
            set MIDAS_DataAcquisitionError 4096
            set MIDAS_DataAcquisitionInfo "$m\n$errorCode\n$errorInfo"
        }

       if {$MIDAS_DataAcquisitionControlServer_Verbose} \
             {puts "exit method Appdo_SetOption with MIDAS_DataAcquisitionCode $MIDAS_DataAcquisitionCode"}

}

proc Appdo_GetOption {args} {return 0}

proc Appdo_GetCounters {{block 0}} {
    return 0
}

proc Appdo_GetRates {{block 0}} {
    return 0
}


#    AGATA digitizer does not implement many of the standard actions

proc doReset {} {global MIDAS_DataAcquisitionCode; set MIDAS_DataAcquisitionCode 0}
proc doStop {} {global MIDAS_DataAcquisitionCode; set MIDAS_DataAcquisitionCode 0}
proc doGo {} {global MIDAS_DataAcquisitionCode; set MIDAS_DataAcquisitionCode 0}

#    but a few it does


proc doSetUp {} {
       global errorCode errorInfo
       global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionState MIDAS_DataAcquisitionReason
       global MIDAS_DataAcquisitionError MIDAS_DataAcquisitionInfo

        set rc [catch {AGATADigitizer::do_SetUpAllDigitizers} m]

        if {$rc != 0} {

            puts "SETUP returned with an error\n$m\n$errorCode\n$errorInfo"

            set MIDAS_DataAcquisitionCode 6
            set MIDAS_DataAcquisitionError 4096
            set MIDAS_DataAcquisitionInfo "$m\n$errorCode\n$errorInfo"
        } else {

            set MIDAS_DataAcquisitionCode 0
        }
}

