#loaded from the Tests window
# reads in the data from the PROM using the button in the main window 
# adds one to the modification .... waits for a prompt from the user and then writes it back.
proc do_upmod {} {

        variable  Digitizer 
        variable  Fpga 
        variable  FpgaList 
        variable  FpgaIDs
        variable  Address
        variable  AddressModifier 
        global errorCode errorInfo

set Prom_control 0x880
set Prom_status 0x881
set Prom_base 0x800
set Prom_limit 128

        if {$Digitizer == -1} {
            InsertLog "Use \"Probe Hardware\" and select a Digitizer"
            Alert "Use Probe Hardware and select a Digitizer"
            return
        }

        if {$Fpga == "Use Probe Hardware"} {
            InsertLog "Use \"Probe Hardware\" and select a FPGA"
            Alert "Use Probe Hardware and select a FPGA"
            return
        }

    InsertLog "Digitizer= $Digitizer"

    InsertLog "Read PROM"

#    not available for Main Boards

        if {$Fpga == "Core: Main Board" || $Fpga == "Segment: Main Board"} {
            InsertLog "Not available for Main Boards"
            Alert "Not available for Main Boards"
            return
        }

# check to see if it has read in correctly 

        set a [ Get_Register $Prom_status ]
	if { $a != 4 } {
             InsertLog "Prom has read back unsuccessfully. Status : $a"
             return
        }

	InsertLog "Prom Read back into RAM"

	set a [ format "%c" [ Get_Register 0x800 ] ]
	
	if { $a == "C" } {
		InsertLog "This is a Core ADC board"
	} elseif { $a == "S" } {
		InsertLog "This is a Segment ADC board. Increment will not be done." 
		return
	} else {
		InsertLog "Not sure what this is : $a [ Get_Register 0x800 ] !"
                Alert "Not sure what this is. See log for further information"
                return
	}
	set a [ Get_Register 0x801 ]
	set b [ Get_Register 0x802 ]
	set c [ Get_Register 0x803 ]
	set d [ Get_Register 0x804 ]
	set e [ Get_Register 0x805 ]
	set f [ Get_Register 0x806 ]
	set g [ Get_Register 0x807 ]
	set serial [ format "%c%c%c%c" $d $c $b $a ]
	set revision [ format "%c" $e ]
	set mod_state [ format "%c%c" $g $f ]

	InsertLog "Serial number : $serial"
	InsertLog "Revision      : $revision"
	InsertLog "Mod state     : $mod_state"
	if { $revision == "B" } {
		if { $mod_state != "0" } {
			InsertLog "\nRev B board : Mod state incorrect $mod_state, expected : 0\n\nIncrement not carried out"
			return 
		} 
	} else {
		if { $mod_state != "02" } { 
			InsertLog "\nRev A board : Mod state incorrect $mod_state, expected : 02\n\nIncrement not carried out"
			return 
		}
	}
# increment the mod_state and write back into the PROM.
# the PROM values are characters

	set f [ expr $f + 1 ] 


# reset the failed flag regardless 
	Set_Register $Prom_control 1
# remove the write protect
	Set_Register $Prom_control 0x80
	Set_Register [ expr $Prom_base + 6 ] $f
	for { set i 0 } { $i < $Prom_limit } { incr i } {
		set a [ expr [ Get_Register $Prom_status ] & 1 ]
		if { $a == 0 } {
			break 
		}
	}
	if { $i == $Prom_limit } {
		InsertLog "Prom is busy longer than $Prom_limit "
	}
	set a [ expr [ Get_Register $Prom_status ] & 8 ]
	if { $a != 0 } {
		InsertLog "Status reporting failed operation. "
	} else {
		InsertLog "Update of Modification number completed "	
	}
# remove the write enable
	Set_Register $Prom_control 0
}
