
#    Note:  This is loaded into the namespace  Check

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 11} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"

   }

  proc do_cal_check {} {
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [ ReadAIDARegister 0x802 ]
		 set Test2 [ ReadAIDARegister 0x803 ]
		 set Test3 [ ReadAIDARegister 0x804 ]
		if { $Test1 == 0xff && $Test2 == 0xf7 && $Test3 == 0xff } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 failed"
		}
      }
	InsertLog "Calibration test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }
  proc do_stamp_check {} {
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [ ReadAIDARegister 0x309 ]
		if { $Test1 == 0x9f  } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 failed"
		}
      }
	InsertLog "ASIC Clock Timestamp check test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc do_redisplay {} {

 
   }
 
   proc Sync_ASIC_Clock {} {
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  set ::AIDA::FEE64 $fee64
	  set val [ ReadAIDARegister 0x300 ]
	  WriteAIDARegister 0x300 [ expr $val | 0x10000	] ;# enable the ASIC clock synchronisation
     }

      after 10 			;# allow time for several sync pulses

      foreach fee64 $::AIDA::ModuleMenu {
	  set ::AIDA::FEE64 $fee64
	  set val [ ReadAIDARegister 0x300 ]
	  WriteAIDARegister 0x300 [ expr $val & 0xFFFF ]		;# remove the enable the ASIC clock synchronisation
     }
      set ::AIDA::FEE64 $BAK   ;#   restore
	do_stamp_check

}
   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

		STAMP_CHECK {do_stamp_check}
		CAL_CHECK	{do_cal_check}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




