
#    Note:  This is loaded into the namespace  TPLOT

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0
    
    variable temperatures ""
    variable T_log ""
    variable T_logfile "Temperatures.txt"

    variable OptTmaxVirtex 65
    variable OptTmaxPSU 35
    variable OptTmaxASIC 55
# temperature plot variables
     variable StartTime ""
	variable StartSeconds 0
	   variable StartBST 0

     foreach fee64 $::AIDA::ModuleMenu {
	     variable virtex_$fee64 {}
	     variable psu_$fee64 {}
	     variable asic_$fee64 {}
	}

#    global variables 
    
    variable MaxGalleries 16
    if {[info exists My_MaxGalleries]} {set MaxGalleries $My_MaxGalleries}
    variable MaxOverlaps 8      ;#  per gallery
    if {[info exists My_MaxOverlaps]} {set MaxOverlaps $My_MaxOverlaps}
    variable MaxTags 50         ;#  per gallery
    if {[info exists My_MaxTags]} {set MaxTags $My_MaxTags}
    variable MaxFits 8          ;#  per gallery
    if {[info exists My_MaxFits]} {set MaxFits $My_MaxFits}
    
    variable numgallery 1
    variable numoverlap $MaxOverlaps
    
    variable currentgallery 1
    variable currentoverlap 1      ;# within current gallery

    variable wscale 10
    if {[info exists My_wscale]} {set wscale $My_wscale}
    variable hscale 10
    if {[info exists My_hscale]} {set hscale $My_hscale}
    
    variable mode1 0
    variable mode1list
    set mode1list [list new add overlap]
    variable mode2 0
    variable mode2list
    set mode2list [list current all]
    variable mode3 0
    variable mode3list
    set mode3list [list linear log]
    
    variable multimodelist [list single multi]
    variable multimode "single"

    variable Colors          ;#  there are $MaxTags Colors
    variable ColorScheme 0

#    define control variables of the form Var(gallery,tag)

    variable dbtagx
    variable dbtagy
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxTags} {incr j} {
            set dbtagx($i,$j) 0
            set dbtagy($i,$j) 0
    }  }
    
#    define control variables of the form Var(gallery,fit)

    variable dbfit
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxFits} {incr j} {
            set dbfit($i,$j) ""
    }  }
    
#    define control variables of the form Var(gallery,overlay)

    variable dbInUse
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbInUse($i,$j) 0
    }  }

    variable dbSpecName
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecName($i,$j) "undefined"
    }  }

    variable dbServerName
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbServerName($i,$j) "undefined"
    }  }

    variable dbSpecPathName
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecPathName($i,$j) "undefined"
    }  }
    
    variable dbSpecRawData
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRawData($i,$j) {}
    }  }
    
    variable dbSpecData
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecData($i,$j) ""
    }  }

    variable dbSpecTitle
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecTitle($i,$j) ""
    }  }
    variable dbSpecDim
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecDim($i,$j) 1
    }  }
    
    variable dbSpecBase
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecBase($i,$j) 0
    }  }
    
    variable dbSpecRange
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRange($i,$j) 65535
    }  }
    
    variable dbXMin
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbXMin($i) 0
    }
    
    variable dbXMax
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbXMax($i) 65535
    }
    
    variable dbYMin
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbYMin($i) 0
    }
    
    variable dbYMax
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbYMax($i) 0
    }

    variable dbSpecBase0
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecBase0($i,$j) 0
    }  }
    
    variable dbSpecRange0
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRange0($i,$j) 65535
    }  }

    variable dbSpecBase1
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecBase1($i,$j) 0
    }  }
    
    variable dbSpecRange1
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRange1($i,$j) 256
    }  }

    variable Compression 1
    variable SpecCont ""
    variable SpecLength ""
    variable DataLength ""
    variable SpectrumList {}
    variable DirectoryList {}
    variable SpecDim 1
    variable SpecB 0
    variable SpecR 0
    variable SpecArgs {}
    variable DataList {}
    variable CustomYView 0
    variable CanvasX 512
    variable CanvasY 512
    variable SpecSize 0
    variable SpecLimit 0
    variable WindowSize 0
    variable Skip0 0
    variable QuikLoad 0
    variable DefCont 0
    variable SpecShow 0
    variable Showing 0
    variable Reloading 0
 
    proc do_ColorScheme {} {
        variable Colors
        variable ColorScheme
    
        set Colors(Black) rgb(0,0,0)
        set Colors(White) rgb(255,255,255)

        if {$ColorScheme == 0} {
    
            set Colors(1) rgb(0,0,255)   ;# blue
            set Colors(2) rgb(0,255,0)   ;# green
            set Colors(3) rgb(255,165,0) ;# orange
            set Colors(4) rgb(255,0,255) ;# magenta
            set Colors(5) rgb(0,255,255) ;# cyan
            set Colors(6) rgb(255,255,0) ;# yellow
            set Colors(7) rgb(128,0,128)   ;# purple
            set Colors(9) rgb(0,128,128) ;# dark green
            set Colors(8) rgb(0,0,0)   ;# black
            set Colors(10) rgb(128,128,0) ;# olive

            set Colors(ActiveGallery) $Colors(Black)  
            set Colors(InActiveGallery) rgb(128,128,128)   ;# grey
            set Colors(Crosshair) $Colors(Black)  
            set Colors(Tag) rgb(255,0,0)   ;# red
            set Colors(ActiveSelection) rgb(0,255,0)   ;# green
            set Colors(InActiveSelection) rgb(255,0,0)   ;# red
            set Colors(Label)  $Colors(Black) 
            set Colors(GalleryBg) White
    
        } else {
    
            set Colors(1) rgb(255,255,0)   ;# !blue
            set Colors(2) rgb(255,0,255)   ;# !green
            set Colors(3) rgb(0,90,255) ;# !orange
            set Colors(4) rgb(0,255,0) ;# !magenta
            set Colors(5) rgb(255,0,0) ;# !cyan
            set Colors(6) rgb(0,0,255) ;# !yellow
            set Colors(7) rgb(128,255,128)   ;# !purple
            set Colors(9) rgb(255,128,128) ;# !dark green
            set Colors(8) rgb(255,255,255)   ;# white
            set Colors(10) rgb(128,128,255) ;# !olive

            set Colors(ActiveGallery) $Colors(White) 
            set Colors(InActiveGallery) rgb(128,128,128)   ;# grey
            set Colors(Crosshair) $Colors(White) 
            set Colors(Tag) rgb(255,0,0)   ;# red
            set Colors(ActiveSelection) rgb(0,255,0)   ;# green
            set Colors(InActiveSelection) rgb(255,0,0)   ;# red
            set Colors(Label)  $Colors(White) 
            set Colors(GalleryBg) Black
        }
    
    }
    
    do_ColorScheme

   proc do_show_1d {} {

       variable currentgallery
       variable currentoverlap

	variable StartSeconds
	variable StartBST

# make some aliases for simplicity       

       upvar #1 dbSpecData($currentgallery,$currentoverlap) SpecData
       upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
       upvar #1 dbSpecDim($currentgallery,$currentoverlap) SpecDim
       upvar #1 dbSpecBase($currentgallery,$currentoverlap) SpecBase
       upvar #1 dbSpecRange($currentgallery,$currentoverlap) SpecRange
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
       upvar #1 dbYMin($currentgallery) YMin
       upvar #1 dbYMax($currentgallery) YMax

       variable Compression
       variable SpecLength
       
       variable mode3
       variable mode3list

       variable SpecLimit
       variable WindowSize
       variable Skip0
       variable CustomYView
       variable Showing
       variable SpecShow

           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim in do_show_1d; internal logic error"; return}

           if {$XMin < $SpecBase} {set XMin $SpecBase}
           if {$XMin == $SpecBase && $Skip0} {set XMin [expr $SpecBase + 1]}
           if {$XMax <= $XMin} {set XMax $SpecRange}
           if {$XMax >= $SpecRange} {set XMax [expr $SpecRange - 1]}

           set SpecLength [expr $XMax - $XMin + 1]
           set WindowSize [expr $XMax - $XMin + 1]
           set Compression [expr max(1, $SpecLength / 1024)]
       
           set ymin 0
           set ymax 80
           set SpecData ""
           set k $XMin
           for {set i $XMin} {$i <= $XMax} {} {
              set item 0
              for {set j 0} {$j < $Compression} {incr j} {
                 switch [lindex $mode3list $mode3] {
                     linear  {set dword [lindex $SpecRawData $i]}
                     log     {
                         set d [expr [lindex $SpecRawData $i] & 0x00000000ffffffff]
                         if {$d <= 0} {set dword 0} else {set dword [expr log($d)]}
                     }
                 }
                 if {$dword > $item} {set item $dword}
                 incr i
                 if {$i > $XMax} {break}
              }
#              if {$item > $ymax} {set ymax $item}
              if {$item < $ymin} {set ymin $item}
              append SpecData "\[[expr ( $k * 60  + $StartSeconds + $StartBST) * 1000 ],$item\],"
              incr k $Compression
           }
           
           if {$CustomYView == 0} {
               set YMin [expr (round ($ymin*9)/10)]
               set YMax [expr (round ($ymax*11)/10)]
           }
           
           set SpecLimit $ymax
              
       set SpecShow 1
       set Showing 1
   }

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }
   

   proc do_redisplay {} {
# modify for the table showing different values for each FEE64
     variable temperatures
     variable allmodules 
     variable Showing
     variable SpecShow

       set SpecShow 1
       set Showing 1

   }
# just show one FEE64 plot for now
   proc do_show_plot {} { 
       variable currentgallery
       variable currentoverlap
       variable SpecShow


	do_collate_Temps ; # collect the temperature data into lists for each FEE
	set currentgallery 1
	set currentoverlap 1
	set fee64 $::AIDA::FEE64
        variable virtex_$fee64
        variable psu_$fee64 
        variable asic_$fee64 
	foreach therm { virtex psu asic } {
		upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
		upvar #1 dbSpecTitle($currentgallery,$currentoverlap) dbSpecTitle
		upvar #1 dbInUse($currentgallery,$currentoverlap) dbInUse
	        upvar #1 dbSpecRange($currentgallery,$currentoverlap) SpecRange
		set SpecRawData [ set [ set therm ]_[ set fee64 ] ]
		set dbInUse 1
		set dbSpecTitle $therm
		set SpecRange [ llength $SpecRawData ]

		do_show_1d

		set currentoverlap [ expr $currentoverlap + 1 ]
	}
}
		
# collect the temperature data into the lists for each of the FEE64 in the system

   proc do_collate_Temps {} {
	   variable StartTime
	   variable StartSeconds
	   variable StartBST

	   variable T_logfile
	   global env

	     set fname [file join $env(MIDASBASE) log $T_logfile ]
             set fid [ open $fname r ] ; # open for read
    		set contents [read $fid ]
        	close $fid
		set records [ split $contents "\n"]
		set StartTime [ join [ lrange [ lindex $records 0 ] 0 3 ] ]
		if { [ lindex [ lindex $records 0 ] 4 ] == "BST" } { 
			set StartBST 3600  
		}  else {
			set StartBST 0 
		}
		set StartSeconds [ clock scan [ join [ lrange [ lindex $records 0 ] 0 5 ] ] ] 
		set BAK $::AIDA::FEE64
	     foreach fee64 $::AIDA::ModuleMenu {

		     variable virtex_$fee64
		     variable psu_$fee64 
		     variable asic_$fee64 

		     set virtex_$fee64 {} ;# empty the lists
		     set psu_$fee64 {}
		     set asic_$fee64 {}
			foreach t_list $records {
				if { [lindex $t_list 6 ] == $fee64 } {
					lappend virtex_$fee64 [ lindex $t_list 7 ] 
					lappend psu_$fee64 [ lindex $t_list 8 ] 
					lappend asic_$fee64 [ lindex $t_list 9 ] 
				}
			}

		}
		set ::AIDA::FEE64 $BAK
}



   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
	variable StartSeconds

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w  [lindex $cgidata 1]
              set vl [second [lindex $cgidata 1]]

               switch -glob [ lindex $w 0 ] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

		   PLOTIT	{do_show_plot}
		   RESETIT	{ do_reset }
		   EXPAND   {
			set currentgallery [lindex $w 1]; set currentoverlap 1
			puts "EXPAND : w = $w"
#			do_pushtag [lindex $w 2]
#			do_pushtag [lindex $w 3]
			do_expand  [lindex $w 2] [lindex $w 3] [lindex $w 4] [lindex $w 5] 
		    }
		    GALLERY  {set currentgallery [lindex $w 1]; set currentoverlap 1; do_pushtag [ expr (( [lindex $w 2] / 1000 ) - $StartSeconds ) / 60 ]}
		    SERVER     { set ::DataAcquisition::ACQSERVER $vl  ; set ::AIDA::FEE64 $vl  }

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}


                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

#    This is a component of Spectrum.tcl copied from analysis.tcl




    
    proc SpectrumReference {} {
       variable currentgallery
       variable currentoverlap
        upvar #1 dbSpecPathName($currentgallery,$currentoverlap) SpecPathName
        return $SpecPathName
    }

   proc do_view {args} {
       variable currentgallery
       variable currentoverlap
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
       upvar #1 dbYMin($currentgallery) YMin
       upvar #1 dbYMax($currentgallery) YMax

       variable SpecLimit
       variable WindowSize
       variable CustomYView
       variable QuikLoad

       set f [lreplace [first $args] 0 0]
   
       switch $f {
           "expand"        {do_expand}
            zoomin -
           "zoom in"       {do_zoom In}
            zoomout -
           "zoom out"      {do_zoom Out}
            times2         {set YMax [expr $YMax*2]; set CustomYView 1}
            divide2        {set YMax [expr $YMax/2]; set CustomYView 1}
            left           {set XMin [expr $XMin - ($WindowSize/4)]; set XMax [expr $XMax - ($WindowSize/4)]}
            right          {set XMin [expr $XMin + ($WindowSize/4)]; set XMax [expr $XMax + ($WindowSize/4)]}
            up             {set YMin [expr $YMin - ($SpecLimit/4)]; set YMax [expr $YMax - ($SpecLimit/4)]; set CustomYView 1}
            down           {set YMin [expr $YMin + ($SpecLimit/4)]; set YMax [expr $YMax + ($SpecLimit/4)]; set CustomYView 1}
            reset          {do_reset}
            invert         {variable ColorScheme; set ColorScheme [expr ($ColorScheme+1)&1]; do_ColorScheme}
           "skip channel 0"    {do_skip "true"}
           "unskip channel 0"  {do_skip "false"}
           "enable QuikLoad"   {set QuikLoad 1}
           "disable QuikLoad"  {set QuikLoad 0}
            default         {InsertLog "Unknown view function $f"}
       }
   }
   
   proc do_arrange {args} {
       variable numgallery
       variable numoverlap
       variable MaxTags
       variable dbInUse
       variable dbtagx
       variable dbtagy
       variable currentgallery
       variable currentoverlap

       set f [lreplace [first $args] 0 0]
   
       switch $f {
           "remove all spectra"   {
                 for {set g 1} {$g <= $numgallery} {incr g} {
                    for {set o 1} {$o <= $numoverlap} {incr o} {
                       if {$dbInUse($g,$o) == 1} {set dbInUse($g,$o) 0}
                    }
                    for {set j 1} {$j <= $MaxTags} {incr j} {
                       if {$dbtagx($g,$j) == 0} {continue}
                       set dbtagx($g,$j) 0; set dbtagy($g,$) 0
                    }
                 }
                 set currentgallery 1
                 set currentoverlap 1
           }
           "remove active spectrum"   {
                 set g $currentgallery
                 for {set o 1} {$o <= $numoverlap} {incr o} {
                     if {$dbInUse($g,$o) == 1} {set dbInUse($g,$o) 0}
                 }
                 for {set j 1} {$j <= $MaxTags} {incr j} {
                     if {$dbtagx($g,$j) == 0} {continue}
                     set dbtagx($g,$j) 0; set dbtagy($g,$j) 0
                 }
                 for {set g 1} {$g <= $numgallery} {incr g} {
                     if {$dbInUse($g,1) == 1} {set currentgallery $g; set currentoverlap 1; break}
                 }
           }

           default                {InsertLog "Unknown arrange function $f"}
       }
   }
   

   

   
     
     
 
 
    
   proc do_cont {def} {
       variable DefCont
       if {$def == "true" || $def == 1} {
         set DefCont 1
       } else {
         set DefCont 0
       }
   }

   proc do_skip {skip} {
       variable currentgallery
       variable currentoverlap
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
   
       upvar #1 dbSpecBase($currentgallery,$currentoverlap) SpecBase
       
       variable Skip0
       
       if {$skip == "true" || $skip == 1} {
         set Skip0 1
       } else {
         set Skip0 0
         if {$XMin == 1} {set XMin $SpecBase}
       }
   }   
    
    proc do_zoom {w} {
       variable MaxTags
       variable dbtagx
       variable currentgallery
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
       variable dbtagx
       
      set ntags 0
      for {set j 1} {$j <= $MaxTags} {incr j} {
          if {$dbtagx($currentgallery,$j) == 0} {continue}
          incr ntags
      }
    
       if {$ntags < 1} {InsertLog "You need 1 tag for zoom"; return}
    
        set x $dbtagx($currentgallery,$ntags)
        set range [expr $XMax - $XMin]
        
        if {$w == "In"} {
           set XMin [expr $x - ($range/4)]
           set XMax [expr $x + ($range/4)]
        } else {
           set XMin [expr $x - $range]
           set XMax [expr $x + $range]        
        }
    }
   
   proc do_pushtag {x} {
       variable currentgallery
       variable numgallery
       variable MaxTags
       
       variable dbInUse
       variable mode2
       variable dbtagx
       variable dbtagy
       
       for {set g 1} {$g <= $numgallery} {incr g} {
           if {$dbInUse($g,1) == 1} {
               if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current
               
               upvar #1 dbSpecRawData($g,1) SpecRawData   ;# take counts from overlap 1
               
               set done 0
               for {set j 1} {$j <= $MaxTags} {incr j} {
                   if {$dbtagx($g,$j) != 0} {continue}

                   set dbtagx($g,$j) [expr round($x)]
                   set dbtagy($g,$j) [lindex $SpecRawData $dbtagx($g,$j)]
                   
                   incr done
                   break    ;#  done 
               }
               if {$done == 0} {InsertLog "too many tags for gallery $g. max supported = $MaxTags"}
           }
       }
   }
   
   proc do_reset {} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable mode2
       
       variable CustomYView
       variable WindowSize
       variable SpecLimit
       
       for {set g 1} {$g<=$numgallery} {incr g} {
         if {$dbInUse($g,1) == 1} {
           if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current
           
       upvar #1 dbXMin($g) XMin
       upvar #1 dbXMax($g) XMax
       upvar #1 dbYMin($g) YMin
       upvar #1 dbYMax($g) YMax
       
       upvar #1 dbSpecBase($g,1) SpecBase
       upvar #1 dbSpecRange($g,1) SpecRange
           
           set XMin $SpecBase
           set XMax $SpecRange

           set WindowSize [expr $XMax - $XMin]
           
           set YMin  0
           set YMax  0
       
         }
       }
       
       set CustomYView 0
       set SpecLimit 0
   }
   
   proc do_expand { x1 x2 y1 y2 } {

       variable currentgallery
       variable currentoverlap
       variable numgallery
       variable numoverlap
       variable dbInUse
       variable mode2
       variable MaxTags
       variable dbtagx
       variable dbXMin
       variable dbXMax
       variable dbYMin
       variable dbYMax

       variable WindowSize
	variable StartSeconds


	   set g $currentgallery

           set dbXMin($g) [ expr ( ( $x1 / 1000 ) - $StartSeconds ) / 60 ]
           set dbXMax($g) [ expr ( ( $x2 / 1000 ) - $StartSeconds ) / 60 ]      
           set dbYMin($g) $y1
           set dbYMax($g) $y2
       
           set WindowSize [expr $dbXMax($currentgallery) - $dbXMin($currentgallery)] 
       

   }

   
   proc do_cleartags {} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable MaxTags
       variable mode2
       variable dbtagx
   
       for {set g 1} {$g<=$numgallery} {incr g} {
         if {$dbInUse($g,1) == 1} {
            if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current
           
            for {set j 1} {$j <= $MaxTags} {incr j} {
                if {$dbtagx($g,$j) == 0} {continue}
                set dbtagx($g,$j) 0; set dbtagy($g,$j) 0
            }
         }
       }
   }
   
   proc do_clearfits {} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable MaxFits
       variable mode2
       variable dbfit
       
       for {set g 1} {$g<=$numgallery} {incr g} {
           if {$dbInUse($g,1) == 1} {
              if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current
   
              for {set j 1} {$j <= $MaxFits} {incr j} {set dbfit($g,$j) ""}
           }
       }
   }
   
   proc do_poptag {} {
       variable MaxTags
       variable currentgallery
       variable dbtagx
        
       set ntags 0
       for {set j 1} {$j <= $MaxTags} {incr j} {
          if {$dbtagx($currentgallery,$j) == 0} {continue}
          incr ntags
       }
   
       if {$ntags < 1} {return}
       
       set dbtagx($currentgallery,$ntags) 0
       set dbtagy($currentgallery,$ntags) 0
   }


    do_redisplay

}   ;# end of if {$started == 0}




