
#    Note:  This is loaded into the namespace  TSCAN

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0
    
    variable temperatures ""
    variable T_log ""
    variable T_logfile "Temperatures.txt"
    variable T_logging 0

    variable OptTmaxVirtex 65
    variable OptTmaxPSU 35
    variable OptTmaxASIC 55

	foreach item $::AIDA::ModuleMenu {
#		InsertLog "Doing create for $item"
    		variable Opt900$item "___ No response"
     		variable Opt901$item "___ No response"
     		variable Opt902$item "___ No response"
     		variable Opt903$item "___ No response"
    		variable Opt904$item "___ No response" 
	}

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }
   
   proc START_TLOG {} {
    variable T_logging
   	   do_Twait start
	   set T_logging 1
   }
   
   proc STOP_TLOG {} {
    variable T_logging
	do_Twait stop
	set T_logging 0
   }
   
   proc do_Twait { n } {
	switch $n {
		start	{ puts "Starting temperature logging" ; set ::TSCAN::T_run 1 ; after 60000 ::TSCAN::do_Twait run }
		run 	{ if { $::TSCAN::T_run == 0 } return ; do_Tlog ; after 60000 ::TSCAN::do_Twait run }
		stop	{ puts "Stopping temperature logging" ; set ::TSCAN::T_run 0 }
	}
   }
   	   
   proc do_Tlog {} {
   	   variable T_log
	   variable T_logfile
	   global env

   	   set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
      	   set T_log ""   
	   set ::AIDA::FEE64 $fee64
           set rc1 [catch {exec ping -c 1 $fee64} m1]
	   if { $rc1 == 0 } {
		do_ShowTemps
		}
	     set fname [file join $env(MIDASBASE) log $T_logfile ]
             set fid [ open $fname a ] 
#	     if { $z != 0 }  { InsertLog "File open failed $fname " }
             set timestamp [clock format [clock seconds]]
             puts $fid "$timestamp $fee64 $T_log"
             close $fid
      }
      set ::AIDA::FEE64 $BAK   ;#   restore
  }

   proc do_redisplay {} {
# modify for the table showing different values for each FEE64
     variable temperatures
     variable allmodules 



      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
     		variable Opt900$fee64
     		variable Opt901$fee64 
     		variable Opt902$fee64 
		variable Opt903$fee64 
		variable Opt904$fee64

	        set ::AIDA::FEE64 $fee64

	 	set Opt900$fee64 $fee64
		if { [ llength $::AIDA::ModuleMenu ] == 1 } { ;# catch the only one module case 
           		set rc1 0
		} else {
			set rc1 [catch {exec ping -c 1 $fee64} m1]
		}
	   if { $rc1 == 0 } {
		do_ShowTemps


		set Opt901$fee64 [ lindex $temperatures 0 ]
		set Opt902$fee64 [ lindex $temperatures 1 ]
		set Opt903$fee64 [ lindex $temperatures 2 ]
	
	        set Opt904$fee64 [ReadAIDARegister 14 ] 
		} else {
			
		set Opt901$fee64 "___ No response"
		set Opt902$fee64 "___ No response"
		set Opt903$fee64 "___ No response"
	
	        set Opt904$fee64 "No response" 
		}
#	InsertLog  "$Opt900 $Opt901 $Opt904"
#      }

      set ::AIDA::FEE64 $BAK   ;#   restore


   }
   proc do_collate_Temps {} {

	   variable T_logfile
	   global env

	     set fname [file join $env(MIDASBASE) log $T_logfile ]
             set fid [ open $fname r ] ; # open for read
    		set contents [read $fid ]
        	close $fid
		set records [ split $contents "\n"]
		set BAK $::AIDA::FEE64
     foreach fee64 $::AIDA::ModuleMenu {
	     set virtex {}
	     set psu {}
	     set asic {}
		foreach t_list $records {
			if { [lindex $t_list 6 ] == $fee64 } {
				lappend virtex [ lindex $t_list 7 ] 
				lappend psu [ lindex $t_list 8 ] 
				lappend asic [ lindex $t_list 9 ] 
			}
		}
		set virtex_length [ llength $virtex ]
		set max 0
		set min 100
		set sum 0
		for { set i 20 } { $i < 80 } { incr i } { set hist$i 0 }
		foreach val $virtex  {
			set sum [ expr $sum + $val ]

			if { $val > $max } { set max $val }
			if { $val < $min } { set min $val }
			set val [ expr int($val) ] 
			set hist$val [ expr [ set hist$val ] +  1 ]
		}
		set avg [ expr $sum / $virtex_length ] 
		InsertLog "$fee64 => Virtex length: $virtex_length | average : $avg | max : $max | min : $min "
		set result {}
		for { set i 20 } { $i < 80 } { incr i } { lappend result [ set hist$i] }
		InsertLog "Histogram => $result "
		set psu_length [ llength $psu ]
		set max 0
		set min 100
		set sum 0 
		foreach val $psu {
			set sum [ expr $sum + $val ] 
			if { $val > $max } { set max $val }
			if { $val < $min } { set min $val }
		}
		set avg [ expr $sum / $psu_length ] 
		InsertLog "$fee64 => PSU length: $psu_length | average : $avg | max : $max | min : $min "
		set asic_length [ llength $asic ]
		set max 0
		set min 100
		set sum 0 
		foreach val $asic {
			set sum [ expr $sum + $val ] 
			if { $val > $max } { set max $val }
			if { $val < $min } { set min $val }
		}
		set avg [ expr $sum / $asic_length ] 
		InsertLog "$fee64 => ASIC length: $asic_length | average : $avg | max : $max | min : $min "
	}
		set ::AIDA::FEE64 $BAK
}

   proc do_ShowTemps {} {
   	variable T_log
	variable temperatures
    	variable OptTmaxVirtex 
    	variable OptTmaxPSU 
    	variable OptTmaxASIC 

      if {![info exists ::ASIC::started]} {
          InsertLog "You must start ASIC Control Window first"
          return
      }
	  WriteAIDARegister 0x200 0          ;#    initiate Virtex temp measurement
	  set vl0 [ReadAIDARegister 0x201]   ;#  get it

	  WriteAIDARegister 0x202 0          ;#    initiate PSU temp measurement
	  set vl1 [ReadAIDARegister 0x203]   ;#  get it

	  WriteAIDARegister 0x204 0          ;#    initiate ASIC temp measurement
	  set vl2 [ReadAIDARegister 0x205]   ;#  get it
	  set m ""
	  set vl0 [ expr $vl0 * 0.0625 ]
	  set vlt0 [format "%2.2f" $vl0]
	if { $vl0 <= $OptTmaxVirtex } {
		lappend m "<font color=green>$vlt0<\/font>"
	} else {
		lappend m "<font color=red>$vlt0<\/font>"
	}
	  set vl1 [ expr $vl1 * 0.0625 ]
	  set vlt1 [format "%2.2f" $vl1]
	if { $vl1 <= $OptTmaxPSU } {
		lappend m "<font color=green>$vlt1<\/font>"
	} else {
		lappend m "<font color=red>$vlt1<\/font>"
	}
	  set vl2 [ expr $vl2 * 0.0625 ]
	  set vlt2 [format "%2.2f" $vl2]
	if { $vl2 <= $OptTmaxASIC } {
		lappend m "<font color=green>$vlt2<\/font>"
	} else {
		lappend m "<font color=red>$vlt2<\/font>"
	}
	lappend T_log $vlt0
 	lappend T_log $vlt1
	lappend T_log $vlt2
      set temperatures $m
   }

   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x90a] 0x0
          WriteAIDARegister [expr 0x90a] 0x1    ;#  force waveform capture 
          WriteAIDARegister [expr 0x90a] 0x0
      }

      set ::AIDA::FEE64 $BAK   ;#  restore

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}


                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




