
#    Note:  This is loaded into the namespace  OPTION

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     do_click

#     LoadOptions
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable PROJECT $::DataAcquisition::PROJECT
    variable ACQSERVER $::DataAcquisition::ACQSERVER

    variable index 0
    variable selected -1

    variable allservers 0


   proc  show_variables {} {
       variable allservers

       InsertLog "allservers=$allservers"
       InsertLog "AcqServers=$::DataAcquisition::ACQSERVERS"
       InsertLog "AcqServer=$::DataAcquisition::ACQSERVER"

   }

      proc Selection {} {
          variable selected

          set selected 0

           set i 1
           foreach item $::R3B::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }

   proc do_redisplay {} {}

   proc do_setOpt {index vl} {

    set i 0
    foreach item [lsort [array names ::Options]] {
       if {$i == "$index"} {set ::Options($item) $vl; break}
       incr i
    }

       SaveOptions
   }

   proc do_newOpt {item} {

       set ::Options($item) "undefined"

       SaveOptions
   }

   proc do_delOpt {index} {

    set i 0
    foreach item [lsort [array names ::Options]] {
       if {$i == "$index"} {unset ::Options($item); break}
       incr i
    }

       SaveOptions
   }

      proc do_Save {} {
        variable allservers
        variable ACQSERVER

        set BAK $::DataAcquisition::ACQSERVER

        foreach server $::DataAcquisition::ACQSERVERS {
           if {$allservers == 0 && $server != $::DataAcquisition::ACQSERVER} continue

           set ::DataAcquisition::ACQSERVER $server
           set  ACQSERVER $::DataAcquisition::ACQSERVER

           InsertLog "Saving R3B4K options to $::R3B::DBRootName/$::R3B::DBNodeBase"

           SaveOptions

           InsertLog "R3B4K options saved for $server"
        }

        set $::DataAcquisition::ACQSERVER $BAK    ;# restore
        set  ACQSERVER $::DataAcquisition::ACQSERVER

#        Elog INFORMATION "R3B4K settings saved to $::R3B::DBRootName/$::R3B::DBNodeBase"

    }

      proc do_Restore {} {
        variable allservers
        variable ACQSERVER

        set BAK $::DataAcquisition::ACQSERVER

        foreach server $::DataAcquisition::ACQSERVERS {
           if {$allservers == 0 && $server != $::DataAcquisition::ACQSERVER} continue

           set ::DataAcquisition::ACQSERVER $server
           set  ACQSERVER $::DataAcquisition::ACQSERVER

           InsertLog "Restoring R3B4K options from $::R3B::DBRootName/$::R3B::DBNodeBase"

           LoadOptions

           InsertLog "R3B4K options restored for $server"
        }

        set $::DataAcquisition::ACQSERVER $BAK    ;# restore
        set  ACQSERVER $::DataAcquisition::ACQSERVER

#        Elog INFORMATION "R3B4K options restored from $::R3B::DBRootName/$::R3B::DBNodeBase"

    }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable allservers

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RESTORE  {do_Restore}
                   SAVE     {do_Save}

                   SERVER     {set ::DataAcquisition::ACQSERVER $vl; LoadOptions}
                   ALLSERVERS {set allservers [expr ($allservers + 1) & 1]}

                   OPTS     {do_setOpt $vl [third [lindex $cgidata 1]]}
                   NEWOPT   {do_newOpt $vl}
                   DELOPT   {do_delOpt $vl}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    LoadOptions


}   ;# end of if {$started == 0}




