

#    TDC Readout  -   3x opcodes

#    30    enable TDC header and EOB in readout
#    31    disable TDC header and EOB in readout
#    32    read status
#    33    set max hits per event
#    34    read max hits per event
#    35    enable TDC error mark
#    36    disable TDC error mark
#    37    enable bypass TDC if error
#    38    disable bypass TDC if error
#    3b    set size of readout FIFO
#    3c    read size 

#    3X0   set control register bit 0
#    3X3   set control register bit 3


     proc do_rdoutopt {p  vl} {

# InsertLog "do_rdoutopt $p $vl"


#    p = 1;    enable TDC header and EOB in readout
#        2;    disable TDC header and EOB in readout
#        3;    enable TDC error mark
#        4;    disable TDC error mark
#        5;    enable bypass TDC if error
#        6;    disable bypass TDC if error

#       10;    set max hits per event
#       11;    set size of readout FIFO

          switch $p {
              1 {set opcode 0x3000}
              2 {set opcode 0x3100}
              3 {set opcode 0x3500}
              4 {set opcode 0x3600}
              5 {set opcode 0x3700}
              6 {set opcode 0x3800}
             10 {set opcode 0x3300}
             11 {set opcode 0x3b00}
          }

          switch $p {
              10 {variable RdOutOpt10; set RdOutOpt10 $vl; set opcode 0x3300}
              11 {variable RdOutOpt11; set RdOutOpt11 $vl; set opcode 0x3b00}
              default {variable RdOutOpt$p; set RdOutOpt$p [expr ([set RdOutOpt$p] + 1) & 1]}
          }

          do_set_opcode $opcode $vl

          redisplay_rdout
     }

     proc redisplay_rdout {} {
         variable RdOutOpt1
         variable RdOutOpt2
         variable RdOutOpt10
         variable RdOutOpt11

         set vl [do_read_opcode 0x3200]
         if {[expr ($vl + 1) & 1] == 0} {set RdOutOpt1 0; set RdOutOpt2 1} else {set RdOutOpt1 1; set RdOutOpt2 0}

         set RdOutOpt10 [do_read_opcode 0x3400]

         set RdOutOpt11 [do_read_opcode 0x3c00]
     }






