

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable numchans 16

    set Menu1 {}
    for {set i 0} {$i <= 15} {incr i} {lappend Menu1 $i}

    set Menu2 {}
    for {set i 0x00} {$i <= 0x9f} {incr i} {lappend Menu2 [format 0x%02x $i]}


    variable UserLabel "not defined"

    for {set i 1} {$i <= $numchans} {incr i} {variable A$i; set A$i 0}

    variable P0 0
    variable P1 0
    variable P2 0
    variable P3 0

    variable P10 0
    variable P11 0
    variable P12 0
    variable P13 0

    variable Fmajor 1
    variable Fminor 0
    variable Fday 2
    variable Fmonth 1
    variable Fyear 2016

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc  show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg
        variable numchans

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
        for {set i 1} {$i <= $numchans} {incr i} {variable A$i; InsertLog "$i [set A$i]"}

       global VHSADCCrate

      InsertLog "VHSADCCrate = $VHSADCCrate"
      InsertLog "crates = $::LyrTech::crateList; boards = $::LyrTech::boardList"
      InsertLog "crateID = $::LyrTech::crateID; boardID = $::LyrTech::boardID"
      InsertLog "all crates = $::LyrTech::allcrates; all boards = $::LyrTech::allboards"
 
   }

   proc do_Setting {w i vl} {
       variable numchans
       variable P1
       variable P2

       InsertLog "do_Setting $w $i $vl"

       switch $i {
         P1  {variable P1; set P1 $vl}
         P2  {variable P2; set P2 $vl}
         P11 {variable P11; set P11 $vl}
         P12 {variable P12; set P12 $vl}
         default {}
       }
   }

   proc do_Adata {w i} {
       variable numchans

       InsertLog "do_Adata $w $i "

       switch -glob $i {
         A00 {do_execute}
         A01 {
             for {set i 1} {$i <= $numchans} {incr i} {variable A$i; set A$i 1}
         }
         A02 {
             for {set i 1} {$i <= $numchans} {incr i} {variable A$i; set A$i 0}
         }
         A*  {variable $i; set $i [expr ([set $i] + 1) & 1]}
         default {}
       }
   }

   proc do_Pdata {w i vl} {
       variable P0
       variable P3
       variable P10
       variable P13
       InsertLog "do_Pdata $w $i $vl"

       switch $i {
         P0   {variable P0; set P0 $vl}
         P3   {variable P3; set P3 $vl}
         P10  {variable P10; set P10 $vl}
         P13  {variable P13; set P13 $vl}
         default {}
       }
   }

    proc do_Write {} {
       variable P0
       variable P1
       variable P2
       variable P3
       
       InsertLog "do_Write"

       set chan $P1
       set reg $P2
       set vl $P3

       WriteVHSADCUserRegister $chan $reg $vl

    }

    proc do_Read {} {
       variable P10
       variable P11
       variable P12
       variable P13

       InsertLog "do_Read"

       set chan $P11
       set reg $P12
       set vl $P13

       set rc [ReadVHSADCUserRegister $chan $reg]
       set P10 [format "0x%08x" $rc]
       set P13 [format "0x%04x" [expr $rc & 0x0000ffff]]

    }

    proc do_execute {} {
       variable numchans

       for {set i 1} {$i <= $numchans} {incr i} {
          variable A$i
          if {[set A$i] == 1} {
              InsertLog "execute $i"
          }
       }

    }

    proc UpdateModule {} {do_Read}


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [first [lindex $cgidata 1]]
               set i [second [lindex $cgidata 1]]
               set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   CRATE     {SelectVHSADCCrate $i}
                   ALLCRATES {set ::LyrTech::allcrates [expr ($::LyrTech::allcrates + 1) & 1]}
                   BOARD     {SelectVHSADCBoard $i}
                   ALLBOARDS {set ::LyrTech::allboards [expr ($::LyrTech::allboards + 1) & 1]}

                   SETTING* {do_Setting $w $i $vl}
                   PDATA*   {do_Pdata $w $i $vl}
                   ADATA*   {do_Adata $w $i}

                   WRITE*    {do_Write}
                   READ*     {do_Read}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
#               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

