

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable FileList {}
    variable File "select bitstream file"

    variable CLKMenu [list External 125Mhz 120Mhz 115Mhz 110Mhz 105Mhz 100Mhz 95Mhz 90Mhz 85Mhz 80Mhz 75Mhz 70Mhz 65Mhz 60Mhz 55Mhz 50Mhz 45Mhz 40Mhz 35Mhz 30Mhz]
    variable ADCClockFreq 105

    variable FPTRIGMenu [list "External Trigger" "TS Sync Pulse"]
    variable FPTRIGMenuIndex 0

    variable NumChans



     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg
        variable FPGAProgramOption
        variable FPTRIGMenuIndex
        variable ADCClockFreq

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
        InsertLog "$FPTRIGMenuIndex; $FPGAProgramOption; $ADCClockFreq;"
   }


     proc UpdateModule {} {}

     proc SetFpgaClock {args} {
        variable ADCClockFreq

        if {$ADCClockFreq == "External"} {
            do_clksrc 0
        } else {
            do_clksrc $ADCClockFreq
        }
     }

     proc do_clk {f} {                             ;# set ADC clock

       if {$f == 0}  {      ;# external clock
           do_clksrc 1
       } else {
           do_clksrc 0   ;# onboard clock (Virtex4)
       }
     }

     proc do_clksrc {vl} {                             ;# set all ADC clocks

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set save1 [set ::LyrTech::crateID]
       set save2 [set ::LyrTech::boardID]

       foreach crateID [set ::LyrTech::crateList] {
         SelectVHSADCCrate $crateID
         foreach boardID [set ::LyrTech::boardList] {
            SelectVHSADCBoard $boardID

            set rc [ReadVHSADCFpgaRegister $boardID 0x08]  ;# clocks control register
            WriteVHSADCFpgaRegister $boardID 0x08 [expr ($rc & 0x00000ff8) + 0x2000 + $vl]  ;# set CLK SRC bits

#       InsertLog "Set Clock Control register to [format 0x%x [expr ($rc & 0x00000ff8) + 0x2000 + $vl]]"

            ::vhsadcC::do_ResetDCM

            UpdateModule
          }
       }
       SelectVHSADCCrate $save1
       SelectVHSADCBoard $save2

       UpdateModule
     }

     proc do_clk105 {args} {do_clksrc 0; do_clks 105}                             ;# set ADC clocks to 105 MHz

     proc do_FpgaReset {} {

       set boardID [set ::LyrTech::boardID]

         set ctrl [ReadVHSADCFpgaRegister $boardID 0x00]  ;#  board control register
         set ctrl [expr $ctrl & 0x000005f8]    ;# remove reserved bits
         WriteVHSADCFpgaRegister $boardID 0x00 [expr $ctrl | 0x100] ;# set INT RST bit  (8)

     }

     proc do_Clock {i vl} {
       variable Options
       variable CLKMenu
       variable ADCClockFreq
       variable FPGAProgramOption

       InsertLog "do_clock $i $vl"

#       0  "ADC Clock value
#       1  "Program ADC clocks"
#       2  "Program option"

        switch $i {
          0 {
            if {$vl == 0} {        ;# external clock
                set ADCClockFreq "External"
            } else {
                set ADCClockFreq [lindex $CLKMenu $vl]
                set ADCClockFreq [string range $ADCClockFreq 0 [expr [string length $ADCClockFreq] - 4]]
            }
            set Options(ADCClockFreq) $ADCClockFreq
          }
          1 {SetFpgaClock}
          2 {set FPGAProgramOption $vl}
 
          default {InsertLog "do_Clock $i $vl: program error"}
        }
        InsertLog "$ADCClockFreq"
     }

     proc do_FPTrig {vl} {
        variable Options
        variable FPTRIGMenu
        variable FPTRIGMenuIndex

       InsertLog "do_FPTrig $vl"

         set FPTRIGMenuIndex $vl
         set Options(FPGAFPTrig) $vl

         set_FPTrig
     }

     proc set_FPTrig {} {
        variable Option

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set save1 [set ::LyrTech::crateID]
       set save2 [set ::LyrTech::boardID]

       foreach crateID [set ::LyrTech::crateList] {
         SelectVHSADCCrate $crateID
         foreach boardID [set ::LyrTech::boardList] {
            SelectVHSADCBoard $boardID

            set reg 0x39
            set chan 0
            set rc [ReadVHSADCUserRegister $chan $reg]
            set z [catch {WriteVHSADCUserRegister $chan $reg [expr ($rc & 0xffbf) + ($Options(FPGAFPTrig) << 6)]} rc]
            if {$z != 0} {InsertLog "Error writing register 0x39 ($x $rc)"}
         }
        }
        SelectVHSADCCrate $save1
        SelectVHSADCBoard $save2
     }

     proc set_TSCtrl {} {
        variable Options

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set save1 [set ::LyrTech::crateID]
       set save2 [set ::LyrTech::boardID]

       foreach crateID [set ::LyrTech::crateList] {
         SelectVHSADCCrate $crateID
         foreach boardID [set ::LyrTech::boardList] {
            SelectVHSADCBoard $boardID

            set reg 0x39
            set chan 0
            set rc [ReadVHSADCUserRegister $chan $reg]
            set z [catch {WriteVHSADCUserRegister $chan $reg [expr ($rc & 0x9fff) + ($Options(FPGATSCtrl) << 13)]} rc]
            if {$z != 0} {InsertLog "Error writing register 0x39 ($x $rc)"}
         }
        }
        SelectVHSADCCrate $save1
        SelectVHSADCBoard $save2
     }

     proc do_FPGA {vl} {
       InsertLog "do_FPGA $vl"

#        0 "Check FPGA supported channels"
#        1 "Generate RESYNC"
#        2 "Generate FPGA Internal Reset"
#        3 "Upload FPGA bitstream file"
#        4 "Program FPGA"
#        5 "Upload & Program FPGA"
#        6 "Upload & Program Flash"
#        7 "Erase Flash"
#        8 "Program Flash from FPGA"

        switch $vl {

          0 {Inquire_NumChans}
          1 {GenerateRESYNC}
          2 {do_FpgaReset}
          3 {do_UpLoadfpga}
          4 {do_Programfpga}
          5 {do_UpLoadfpga; do_Programfpga}
          6 {do_UpLoadfpga; do_ProgramFlash}
          7 {do_EraseFlash}
          8 {do_ProgramBoot}

          default {InsertLog "do_FPGA $vl: program error"}
        }
     }

    proc Inquire_NumChans {} {
       variable NumChans

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set save1 [set ::LyrTech::crateID]
       set save2 [set ::LyrTech::boardID]

       foreach crateID [set ::LyrTech::crateList] {
         SelectVHSADCCrate $crateID
         foreach boardID [set ::LyrTech::boardList] {
            SelectVHSADCBoard $boardID

            set NumChans($crateID,$boardID) 0

            set reg 0x82
            set chan 0
            set rc [ReadVHSADCUserRegister $chan $reg]
            set nc [expr $rc & 0x00ff]
            if {$nc < 1 || $nc > 16} {set nc 1}    ;# set a default if value return is invalid
            set NumChans($boardID) $nc
            set ds [expr ($rc & 0xf000) >> 12]
            if {$ds == 0} {set ds 4}               ;#  default for older firmwares
            set ro 0
            if {$ds == 4} {set ro 32}
            if {$ds == 2} {set ro 16}

            InsertLog "Crate $crateID board $boardID detected to support $NumChans($crateID,$boardID) channels and $ro bit readout"
         }
        }
        SelectVHSADCCrate $save1
        SelectVHSADCBoard $save2
     }


proc GenerateRESYNC {} {

#   if {![midas-confirmation "This action will reset all ADC timestamps to zero\nDo you wish to continue?"]} then {return}

   do_GenerateRESYNC 

}

proc do_GenerateRESYNC {} {

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set save1 [set ::LyrTech::crateID]
       set save2 [set ::LyrTech::boardID]

       foreach crateID [set ::LyrTech::crateList] {
         SelectVHSADCCrate $crateID
         foreach boardID [set ::LyrTech::boardList] {
            SelectVHSADCBoard $boardID

        set reg 0x70
        set chan 0        
        set z [catch {ReadVHSADCUserRegister $chan $reg} R70]
           if {$z != 0} {
           InsertLog "Error reading register offset=0x70 ($z)"
           break
        }
#insert-log "ReadVHSADCUserRegister $boardID  $reg [format 0x%x $R70]"
        set vl [expr ($R70 & 0xffdf)]
        set z [catch {WriteVHSADCUserRegister $chan $reg $vl} rc]  ;# remove bit 5
           if {$z != 0} {
           InsertLog "Error writing register offset=0x70 ($z $rc)"
        }
#insert-log "WriteVHSADCUserRegister $boardID  $reg [format 0x%x $vl]"
        set vl [expr $vl | 0x20]
        set z [catch {WriteVHSADCUserRegister $chan $reg $vl} rc]   ;#  set bit 5
#insert-log "WriteVHSADCUserRegister $boardID  $reg [format 0x%x $vl]"
           if {$z != 0} {
           InsertLog "Error writing register offset=0x39 ($z $rc)"
        }
        set vl [expr ($R70 & 0xffdf)]
        set z [catch {WriteVHSADCUserRegister $chan $reg $vl} rc]  ;# remove bit 5
#insert-log "WriteVHSADCUserRegister $boardID  $reg [format 0x%x $vl]"
           if {$z != 0} {
           InsertLog "Error writing register offset=0x70 ($z $rc)"
        }
     
     }
    }
        SelectVHSADCCrate $save1
        SelectVHSADCBoard $save2
}

     proc do_File {vl} {
        variable File
        set File $vl
    }

     proc Get_BitStreamFiles {} {
        global env
        variable FileList
        variable File

        set FirmwareDir [file join $env(MIDASBASE) TclHttpd Html LyrTech BitStream]

        set z [catch {file isdirectory $FirmwareDir} m]
        if {$z != 0 || $m == 0} {
            Alert "Unable to access $FirmwareDir or $FirmwareDir is not a directory"
            return
        }

        set arg "-name \"*bit\""
        set z [catch {eval exec find $FirmwareDir $arg} m]

        if {$z != 0} {
            Alert "Unable to obtain firmware files: $m"
            return
        }

        set FileList {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend FileList $item
        }

        if {[llength $FileList] == 0} {set File "undefined"} else {set File [first $FileList]}
     }

     proc do_UpLoadfpga {} {}

     proc do_Programfpga {} {}

     proc do_ProgramFlash {} {}

     proc do_EraseFlash {} {}

     proc do_ProgramBoot {} {

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set save1 [set ::LyrTech::crateID]
       set save2 [set ::LyrTech::boardID]

       foreach crateID [set ::LyrTech::crateList] {
         SelectVHSADCCrate $crateID
         foreach boardID [set ::LyrTech::boardList] {
            SelectVHSADCBoard $boardID

            set z [catch {VHSADCFlashBoot $boardID} rc]
            if {$z == 0} {
                if {[string range $rc 0 2] == "0x0"} then {
                   InsertLog "FlashBoot for crate $crateID board $boardID successful"
                } else {
                   InsertLog "FlashBoot for crate $crateID board $boardID failed\n$rc"
                }
            } else {
                InsertLog "FlashBoot for crate $crateID board $boardID failed\n$rc"
            }
         }
        }
        SelectVHSADCCrate $save1
        SelectVHSADCBoard $save2
     }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [first [lindex $cgidata 1]]
               set i [second [lindex $cgidata 1]]
               set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   CRATE     {SelectVHSADCCrate $i}
                   ALLCRATES {set ::LyrTech::allcrates [expr ($::LyrTech::allcrates + 1) & 1]}
                   BOARD     {SelectVHSADCBoard $i}
                   ALLBOARDS {set ::LyrTech::allboards [expr ($::LyrTech::allboards + 1) & 1]}

                   CLOCK    {do_Clock $i $vl}
                   FPTRIG   {do_FPTrig $i}
                   FPGA     {do_FPGA $i}

                   FILE {do_File $i}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               UpdateModule
           }
       }
    }

    Get_BitStreamFiles

}   ;# end of if {$started == 0}

