

#    experiment run control for PULSER - taken from sys.tcl

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0


variable Options

variable Supported_Modules {PULSER}


   proc load_Options {} {LoadOptions}
   proc update_Options {} {SaveOptions}

   proc Set_Options {} {
      variable Options
      variable Supported_Modules

      load_Options

   if {![info exists Options(PULSER_GroupBase)]} {set Options(PULSER_GroupBase) 1}
   if {![info exists Options(Include.PULSER)]} {set Options(Include.PULSER) 1}
   if {![info exists Options(Histogram.PULSER)]} {set Options(Histogram.PULSER) 1}

      if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 2000}
      if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 2000}
      if {![info exists Options(Stat.shift)]} {set Options(Stat.shift) 0}
      if {![info exists Options(Stat.offset)]} {set Options(Stat.offset) 1}

   if {![info exists Options(PULSER.channels)]} {set Options(PULSER.channels) 4096}
   if {![info exists Options(PULSER.offset)]} {set Options(PULSER.offset) 0}
   if {![info exists Options(PULSER.shift)]} {set Options(PULSER.shift) 0}

    if {![info exists Options(DataAcqPgm)]} {set Options(DataAcqPgm) PULSERExecV1}

      update_Options
   }

   proc Dump_Raw_Data {} {
      variable Supported_Modules

      set info ""

      foreach module $Supported_Modules {append info [Dump_Raw_[set module]_Data]}

      return $info
   }

proc Dump_Raw_PULSER_Data {} {

   set info "ASIC data Version 1 : $::DataAcquisition::ACQSERVER\n"
   set c 0
   for {set offset 0} {$offset <= 300} {incr offset 100} {

     DataAcqCommand 19 "Getting Raw Data" "11 $offset" 2
     set data [ReadNetVar NetVar.EXEC.Response]

     foreach word $data {
         set word $word
         if {$word == 0xaa5555aa} then {
             append info "\n$word - end of dump\n"
             break
         }
         if {$word == 0x55aaaa55} then {
             append info "\n$word - end of event\n"
             continue
         }
         append info "$word "
         set w [expr ($word >> 30) & 3]
         set det [expr ($word >> 27) & 7]
         set chan [expr ($word >> 20) & 31]
         if {$chan < 16} {set range L} else {set range H; set chan [expr $chan & 15]}
         set dat [format 0x%4x [expr $word & 0x0000ffff]]

         if {$c>10 } { set c 0 ; append info "\n"}
     }
   }

   return "$info"
}
proc doReset {} {

puts "executing doReset for PULSER"

     Set_Options; make-UIregisters

     Reset_Electronics
	InsertLog "Reset in sys.tcl"

     DataAcqCommand 9 "Reset"

     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 1 "disconnect xfer stream #0" 0 2
     }

     if {[ReadNetVar NetVar.DACQ.Ctx2enable] == 1}  {
         DataAcqCommand 2 "disconnect xfer stream #1" 0 2
     }
}


   proc PULSER_DAQ-halt {} {

 puts "PULSER_DAQ-halt"
   }

   proc PULSER_DAQ-go {} {

 	puts "PULSER_DAQ-go"
   }

  proc PULSER_DAQ-reset {} {

 puts "PULSER_DAQ-reset"
   }

  proc PULSER_DAQ-setup {} {

 	puts "PULSER_DAQ-setup"
   }

proc create_PULSER_spectra {} {
   variable Options

     for {set i 0} {$i < 128} {incr i} {

        set z [catch {CreateSpectrum1D Pulse.$i $Options(PULSER.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
           InsertLog "Error attempting to Create spectrum Pulse.$i"
            error $m
         }

         map_spectrum "Pulse.$i $Options(PULSER_GroupBase) 0 $Options(PULSER.offset) $Options(PULSER.shift)"
     }

}

    make-UIregisters

    Set_Options

