# Note:  This is loaded in the namespace
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {  ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_test01 { params } { 
	
	# It powers up N non-adjacent channels each time .
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	set vcall         96;#[lindex [lindex $params 1] 3] ;# [V]
	set vcalh         144;#[lindex [lindex $params 1] 4] ;# [V]
	set pulseNumber   512;#[lindex [lindex $params 1] 5] ;# [a.u.]
	set pulseWidth    1000;#[lindex [lindex $params 1] 6] ;# [10ns]
	set pulseDelay    19000;#[lindex [lindex $params 1] 7] ;# [10ns]
	
	do_getState 
	# Start DAQ.
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 1 } {return "Daq not started properly.";}
	
	# Loop over individual side.
	foreach itrSide [set ::R3B::[set ::R3B::R3B4K].SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ::R3B::[set ::R3B::R3B4K].ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		# Enable test pulse injection
		set_asicValidate $itrSide $itrAsic 1
		# Set pulse params
		do_loadPulseParams $pulseWidth $pulseDelay $pulseNumber
		
		## ==
		# TO BE REMOVED
		foreach itrPkTm {0 7 15} { ;#[*0.5us+0.5us]
		    ## ==
		    
		    # Set file name
		    set fileName  /MIDAS/SpecData/R3B/TestData/
		    append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
		    append fileName "Test01-"
		    append fileName "Side$itrSide-Asic$itrAsic-PkTm$itrPkTm.txt"
		    
		    # Create file and set permissions.
		    set flagOpen [catch {open $fileName w} fileInput]
		    set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
		    if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
		    if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
		    
		    # Flush file header.
		    puts $fileInput "$itrSide $itrAsic $itrPkTm"
		    flush $fileInput
		    
		    # ==
		    # TO BE REMOVED
		    # Set register PkTm and SpPt
		    # 4MSB = PkTm, 4LSB = Sample.
		    set valuePkTm $itrPkTm;# [*0.5us+0.5us]
		    set valuePkTmAndSpPt [expr ($valuePkTm << 4) | 0xf];
		    set registerPkTmAndSpPt 4 ;
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPkTmAndSpPt] $valuePkTmAndSpPt
		    # ==
		    
		    # Set pulse amplitude.
		    set voltStep [expr 2.0/256] ;# [V]
		    set valueVcalh $vcalh ;#[expr round( ($vcalh)/$voltStep ) ]
		    set valueVcall $vcall ;#[expr round( ($vcall)/$voltStep ) ]
		    set registerVcalh 16
		    set registerVcall 17
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcalh] $valueVcalh
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcall] $valueVcall
		    
		    # Loop over individual channels.
		    set channelNumber 128
		    set channelGroup 4
		    for {set itrGroup 0} {$itrGroup < $channelNumber/$channelGroup} {incr itrGroup} {
			
			# To run on subset of channel.
			# if {$itrGroup != 0 } { continue;}
			
			for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
			    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
			    
			    set valuePlsInj [expr int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
			    set registerPlsInj [expr int ( 64 + ($dummyChannel/8) )]
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPlsInj] $valuePlsInj
			    
			    set valuePwr [expr 255 - int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
			    set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
			    
			}
			# after 1000
			
			# Inject pulses 
			do_testPulse $pulseWidth $pulseDelay $pulseNumber
			
			for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
			    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
			    set fileName "E.$itrSide.$itrAsic.$dummyChannel"
			    # Empty the content of the histogram 
			    # Check also that the histogram has been created.
			    if { [ZeroSpectrum $fileName] != 0 } { 
				return "Histograms E.$itrSide.$itrAsic.* were not created";}
			}
			do_testPulse $pulseWidth $pulseDelay $pulseNumber
			
			for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
			    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
			    set plot  [do_analyseSpectra $itrSide $itrAsic $dummyChannel]
			    set range [lindex $plot 0]
			    set data  [lindex $plot 1]
			    puts $fileInput "$dummyChannel $range"
			    puts $fileInput $data
			    flush $fileInput
			}
			
			# Power off channel.
			for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
			    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
			    
			    set registerPwr [expr int (80 + ($dummyChannel/8) )]
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
			    
			    set registerPlsInj [expr int (64 + ($dummyChannel/8) )]
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPlsInj] 0
			}
		    } ;# end of loop over channel.
		    
		    close $fileInput
		    
		} ;#end of for each on itrPkTm	
		
		# Disable test pulse injection
		set_asicValidate $itrSide $itrAsic 0 
		
	    } ;# end of loop over asic.
	} ;#end of loop over side.
	
	# Stop DAQ
	do_getState
	after 500 set timeout 1
	do_stop
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 0 } {return "Daq did not stop correctly";}
	
	return "Test completed"
    }
    
    proc do_setReg { params } {
	
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	set registerId    [lindex [lindex $params 1] 3]
	set registerValue [lindex [lindex $params 1] 4]
	
	WriteR3BASICRegister [expr ($sideUnderTest << 18) + ($asicUnderTest << 10) + $registerId] $registerValue
	set reading [ReadR3BASICRegister [expr ($sideUnderTest << 18) + ($asicUnderTest << 10) + $registerId]]
	
	return "Setting Side:$sideUnderTest Asic:$asicUnderTest RegId:$registerId RegVal:$registerValue Reading:$reading"
    }
    
    proc do_readReg { params } {
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	set text "Side: $sideUnderTest; Asic: $asicUnderTest"
	for {set itrReg 0} {$itrReg < 96} {incr itrReg} {
	    set reading [ReadR3BASICRegister [expr ($sideUnderTest << 18) + ($asicUnderTest << 10) + $itrReg]]
	    append text "\n Reg:$itrReg = $reading "
	}
	
	return "$text"
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	# InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    INITIALIZE_ASICS {  InsertLog "[do_powerOffFrontEnd]";}
		    INITIALIZE_DAQ   { InsertLog "[do_initializeDaq $cgidata]" }
		    RESET    { set started 0; }
 		    TEST01 { InsertLog "[do_test01 $cgidata]" }
		    SET_REG { InsertLog "[do_setReg $cgidata]" }
		    READ_REG { InsertLog "[do_readReg $cgidata]" }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}

