# Note:  This is loaded in the namespace
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_loadOffsetEnTh { params } {
	
	variable msgIden
	
	set fileName $params
	
	
	# Open file.
	set f [open $fileName]
	
	# UNCOMMENT FOR FILE WITH HEADER.
	# # Get header.
	# variable side
	# variable asic
	# if {[gets $f  line] >= 0} {
	#     set side    [lindex $line 0] ;
	#     set asic    [lindex $line 1] ;
	# }
	
	# Get body.
	while {[gets $f  line] >= 0} {
	    set side    [lindex $line 0] ; # Remove if no header
	    set asic    [lindex $line 1] ; # Remove if no header
	    set channel [lindex $line 2];
	    set offset  [lindex $line 3];
	    
	    if {$offset >= 0} {
		set page 3
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$channel) ] $offset  
	    } elseif {$offset < 0} {
		set page 3
	 	WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$channel) ] [expr abs($offset) + 127];
	    }
	    
	}
	
	return $fileName
    }
    
    proc do_loadOffsetTmStTh { params } {
	
	
	variable msgIden
	
	set fileName $params
	
	# Open file.
	set f [open $fileName]
	
	# Get header.
	variable side
	variable asic
	if {[gets $f  line] >= 0} {
	    set side    [lindex $line 0] ;
	    set asic    [lindex $line 1] ;
	}
	
	# Get body.
	while {[gets $f  line] >= 0} {
	    set channel [lindex $line 0]
	    set offset  [lindex $line 1]
	    
	    # set offset   $max;# [expr round($mean-0*$stdDev)]
	    
	    if {$offset >= 0} {
		set page 2
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$channel) ] $offset  
	    } elseif {$offset < 0} {
		set page 2
	 	WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$channel) ] [expr abs($offset) + 127];
	    }
	    
	}
	
	return $fileName
    }
    
    proc do_measurePedestal {params} {
	
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2] 
	set tmStThMin 108 ;# [DAC]
	set tmStThMax 148 ;# [DAC]
	set tmStThStep 1  ;# [DAC]
	set deltaT 500 ;# [ms]
	
	# Start DAQ.
	do_getState
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if {[do_getState] != 1} {return "DAQ did not start" } 
	
	# Loop over individual side.
	foreach itrSide [set ::R3B::[set ::R3B::R3B4K].SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ::R3B::[set ::R3B::R3B4K].ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		# Loop over PkTm and load offsets.
		foreach itrPkTm {14 126 254} {
		    
		    # Set PkTm.
		    set registerPkTm 4
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPkTm] $itrPkTm 
		    # Set file name
		    set fileName  /MIDAS/SpecData/R3B/TestData/
		    append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
		    append fileName "NoiseFloor-TmStTh-"
		    append fileName "Side$itrSide-Asic$itrAsic-Reg4-$itrPkTm-after-tuning.txt"
		    
		    # Load tuning.
		    set pathEnTh   /MIDAS/SpecData/R3B/TestData/calibrationFiles/WillFiles/
		    set pathTmStTh /MIDAS/SpecData/R3B/TestData/calibrationFiles/WillFiles/
		    
		    if {$itrAsic==1 && $itrPkTm==14} {
			append pathEnTh   2015-03-18-TuneEthCoarse-Side1-Asic1-PkTm0.5us-offset.txt 
			append pathTmStTh 2015-04-20-TuneTmStThCoarse-Side1-Asic1-PkTm0.5us-offsetw.txt   
		    } elseif {$itrAsic==1 && $itrPkTm==126} {
			append pathEnTh   2015-03-18-TuneEthCoarse-Side1-Asic1-PkTm4.0us-offset.txt
			append pathTmStTh 2015-04-20-TuneTmStThCoarse-Side1-Asic1-PkTm4.0us-offsetw.txt
		    } elseif {$itrAsic==1 && $itrPkTm==254} {
			append pathEnTh   2015-03-17-TuneEthCoarse-Side1-Asic1-PkTm8.0us-offset.txt
			append pathTmStTh 2015-04-20-TuneTmStThCoarse-Side1-Asic1-PkTm8.0us-offsetw.txt
		    } 
		    InsertLog "[do_loadOffsetEnTh $pathEnTh]"
		    InsertLog "[do_loadOffsetTmStTh $pathTmStTh]"
		    # --
		    
		    # Create file and set permissions.
		    set flagOpen [catch {open $fileName w} fileInput]
		    set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
		    if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
		    if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
		    
		    # Flush file header.
		    puts $fileInput "$itrSide $itrAsic $tmStThMin $tmStThMax $tmStThStep"
		    flush $fileInput
		    
		    # Zero histograms.
		    set channelNumber 128
		    for {set itrChannel 0} {$itrChannel < $channelNumber} {set itrChannel [expr $itrChannel+8]} {
			set fileName "E.$itrSide.$itrAsic.$itrChannel"
			# This should zero the histogram.
			ZeroSpectrum $fileName
		    }
		    
		    # Set EnTh.
		    set registerEnTh 15
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerEnTh] 128
		    
		    # Loop over TmStTh from higher to lower value.
		    for {set itrTmStTh $tmStThMin} {$itrTmStTh < $tmStThMax} {set itrTmStTh [expr $itrTmStTh+$tmStThStep]} { 
			
			# Set TmStTh.
			set registerTmStTh 14
			WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerTmStTh] $itrTmStTh
			
			# Loop over individual channels.
			set channelNumber 128
			set channelGroup 8
			for {set itrGroup 0} {$itrGroup < $channelNumber/$channelGroup} {incr itrGroup} {
			    
			    # if {$itrGroup >= 1 } { continue;}
			    
			    # Power ON channels.
			    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				set valuePwr [expr 255 - int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
				set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
			    }
			    
			    # Wait to switch ON.
			    after $deltaT ;# [ms]
			    
			    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				set fileName "E.$itrSide.$itrAsic.$dummyChannel"
				# Empty the content of the histogram 
				# Check also that the histogram has been created.
				if { [ZeroSpectrum $fileName] != 0 } { 
				    return "Histograms E.$itrSide.$itrAsic.* were not created";}
			    }
			    
			    # Wait.
			    after $deltaT ;# [ms] 
			    
			    # Save data to file.
			    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				set plot  [do_analyseSpectra $itrSide $itrAsic $dummyChannel]
				set range [lindex $plot 0]
				set data  [lindex $plot 1]
				puts $fileInput "$dummyChannel $itrTmStTh $range"
				puts $fileInput $data
				flush $fileInput
			    }
			    
			    # Power off channel.
			    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
			    }
			    
			} ;# End loop over channels
			
		    } ;# End loop over TmStTh.
		    
		    close $fileInput
		    
		} ;# end of foreach itrPkTm
		
	    } ;# end of loop over asic.
	}  ;#end of loop over side.
	
	# Stop DAQ
	do_getState
	after 500 set timeout 1
	do_stop
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 0 } { return "Daq did not stop correctly";}
	
	return "Measurement completed" 
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    INITIALIZE_ASICS   { InsertLog "[do_powerOffFrontEnd]"; }
		    INITIALIZE_DAQ     { InsertLog "[do_initializeDaq $cgidata]"; }
		    MEASURE_PEDESTAL   { InsertLog "[do_measurePedestal $cgidata]"; }
		    RESET              { set started 0; }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}
