
#    Note:  This is loaded into the namespace  R3B_Diagnostics

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable testing 0
    variable running 0

    variable AddrSpaceList

    variable Offset0x000
    variable Offset0x400
    variable Offset0x800
    variable Offset0xc00

    variable AddrSpace
    variable Address
    variable Offset
    variable SData
    variable GData


     set AddrSpaceList [list \
         "Version & Date registers: 0x000" \
         "DMA registers: 0x400" \
         "Calibration registers: 0x800" \
         "ASIC registers: 0xc00"  \
    ]

    set Offset0x000 [list \
       "firmware date:  0x00"  \
       "firmware version:  0x04"  \
    ]

    set Offset0x400 [list \
       "Control:  0x00"  \
       "Status:  0x04"  \
       "DMA Area base address:  0x08"  \
       "Burst Length:  0x0c"  \
       "Block Size:  0x10"  \
       "Buffer Size:  0x14"  \
       "Buffer Read Pointer:  0x18"  \
       "Buffer Write Pointer:  0x1c"  \
       "Write Byte Low:  0x20"  \
       "Write Byte High:  0x24"  \
       "Timer Counter Low: 0x28" \
       "Timer Counter High: 0x2c" \
    ]

    set Offset0x800 [list \
       "Control:  0x00"  \
       "Status:   0x04"  \
       "Calibration Status Ch0:  0x08"  \
       "Calibration Status Ch0:  0x0c"  \
       "Calibration Status Ch0:  0x10"  \
       "Calibration Status Ch0:  0x14"  \
    ]

    set Offset0xc00 [list \
       "Control:  0x00"  \
       "Val Pulse width:  0x04"  \
       "Val Pulse delay:  0x08"  \
       "Number of Pulses:  0x0c"  \
       "PulseGen width:  0x10"  \
       "Rising edge count 0-31:  0x14"  \
       "Rising edge count 32-63:  0x18"  \
    ]


    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable SData
        variable GData
        variable testing
        variable running

#        global XR3BAccessServerHost XR3BAccessServerPort
#        global XR3BASICAccessServerHost XR3BASICAccessServerPort

        InsertLog "R3B4K = $::R3B::R3B4K"
        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Offset=$Offset; SetData=$SData; GetData=$GData"
#       InsertLog "XR3BAccessServerHost=$XR3BAccessServerHost; XR3BAccessServerPort=$XR3BAccessServerPort"
#        InsertLog "XR3BASICAccessServerHost=$XR3BASICAccessServerHost; XR3BASICAccessServerPort=$XR3BASICAccessServerPort"

        InsertLog "$Address  $Offset  returns [ReadR3BRegister [expr ($Address + $Offset) >> 2]]"
        InsertLog "testing = $testing"
        InsertLog "running = $running"
        InsertLog "[namespace current]"
   }

   proc starttest {} {
       variable testing
       variable running
       
       set testing 1
       set running 0

   InsertLog "$testing $running"

       after 100  {
#          set z [catch {::namespace inscope ::urn:R3B_Diagnostics runtest} m]
           set z [catch {::R3B_Diagnostics::runtest} m]
           InsertLog "$z $m"
       }
   }

   proc runtest {} {
       variable testing
       variable running 

       set running 1
 
       for {set i 0} {$i < 1000} {incr i} {
           if {$testing == 0} {set running 0;return}
           incr testing
           after 5000
       }
   }

   proc do_expert {cmd p} {
       variable testing

       switch $cmd {

          Run_Test {
             switch $p {
               0  {InsertLog "starting test"; starttest}
               1  {InsertLog "ending test"; set testing 0}
             }
          }

          default {}
       }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {WriteR3BRegister [expr ($Address>>2) + ($Offset>>2)] $SData}
                GET      {set GData [ReadR3BRegister [expr ($Address>>2) + ($Offset>>2)]]}
                SETGET   {
                    WriteR3BRegister [expr ($Address>>2) + ($Offset>>2)] $SData
                    set GData [ReadR3BRegister [expr ($Address>>2) + ($Offset>>2)]]
                }

                ADDRSPACE  {
                    set Address [last [lindex $cgidata 1]]
                    set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"
                    set Offset 0
                }
                OFFSET     {set Offset [last [lindex $cgidata 1]]}
                SDATA      {set SData  [last [lindex $cgidata 1]]}

                MODULE     {set ::R3B::R3B4K $vl}

                EXPERT   {do_expert $vl  [third [lindex $cgidata 1]]}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

