# TODO :
# - put everything in a namespace. DONE.
# - clean code.
# - initialize ASICs should automatically initialize all the avaialble asics.

# namespace eval testCommon {

# This takes care of initializatiation.
proc do_all {} {
    
    after 5000 set timeout 1
    do_reset
    vwait timeout
    InsertLog "DORESET State  [do_getState]" 
    
    after 1000 set timeout 1
    do_histogramSettings 1 "E" 4096 0 0 
    vwait timeout
    
    after 5000 set timeout 1
    do_enableHistogramming
    vwait timeout
    InsertLog "DOENHIST State  [do_getState]"
    
    after 100000 set timeout 1
    do_setup 
    vwait timeout
    InsertLog "DOSETUP State  [do_getState]"
    
    after 1000 set timeout 1
    do_setDMABuffer
    vwait timeout
    
    #after 10000 set timeout 1
    #do_go
    #vwait timeout
    #InsertLog "DOGO State  [do_getState]"
    
    #after 5000 set state timeout
    #do_stop
    #vwait state
    #InsertLog "DOSTOP State  [do_getState]"
    
}

# This enables the histogramming.
proc do_enableHistogramming {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqSetOption "HistEnable=1"
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption "$AcqSetOption"} m]
    } else {;}
    
}

# This sets the burst size and 
# the buffer size for the DMA.
proc do_setDMABuffer {} {
    
    variable serverName $::R3B::R3B4K
    variable burstSize 64
    variable blockSize 1
    
    WriteR3BRegister [expr 0x100 + 3] $burstSize
    WriteR3BRegister [expr 0x100 + 4] $blockSize
}

# This starts the data acquisition.
proc do_go {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    set server_name $::DataAcquisition::ACQSERVER
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoGo "$AcqParameter"} m]
    } else {;}
    
}

# This stops the data acquisition.
proc do_stop {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    set server_name $::DataAcquisition::ACQSERVER
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoStop "$AcqParameter"} m]
    } else { InsertLog "ERROR: not possible to start data acquistion on $server_name"}
    
}

proc do_reset {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoReset "$AcqParameter"} m]
    } else {;}

}

proc do_setup {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    if { [info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	 $MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoSetUp "$AcqParameter"} m]
    } else {;}
    
}

# Check the status of the DAQ: 
#    code (int)  state (string)
#       0           stopped
#       1           going
#       2           reset
#       3           setting up
#       4           changing to going
#       5           changing to stopped
#       6           error   
#       7           changing to reset
#       8           undefined 
#       9           executing 

proc do_getState {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
    } else {;}
    
    if {$rc != 0} {
	set rc -1
    } else {
	set rc [lindex $m 1]
    }
    return $rc
}

proc do_initializeASICs { params } {
    
    # set name [lindex [lindex $params 1] 0]
    set side_under_test   [lindex [lindex $params 1] 1] ;
    set asic_under_test   [lindex [lindex $params 1] 2] ;
    
    # Loop over individual side.
    set side_number 2
    for {set itr_side 0} {$itr_side < $side_number} {incr itr_side} {
	
	if { $itr_side!=$side_under_test } {continue;}
	
	# Loop over individual asic.
	set asic_number 16
	for {set itr_asic 0} {$itr_asic < $asic_number} {incr itr_asic} {
	    
	    if { $itr_asic!=$asic_under_test } {continue;}
	    
	    # Loop over individual channels.
	    set channel_number 128
	    for {set itr_ch 0} {$itr_ch < $channel_number} {incr itr_ch} {
		
		# Enable charge injection and power up.
		set REGISTER_cal [expr 64 + ($itr_ch/8)]
		set REGISTER_pwr [expr 80 + ($itr_ch/8)]
		WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_pwr] 255
		WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_cal] 255
		
	    } ;# end of loop over channel.
	} ;# end of loop over asic.
    } ;#end of loop over side.
    
    return "(SIDE $side_under_test; ASIC $asic_under_test) has been initialized."
}

# This controls the pulse injection.
proc do_TestPulse {pulse_width pulse_delay pulse_number} {
    
    # Stop any injection of pulses.
    WriteR3BRegister 0x300 0
    # Reset to load values.
    WriteR3BRegister 0x300 4
    
    # Set registers:
    # reg 1 - p_width
    # reg 2 - p_delay
    # reg 3 - p_number
    WriteR3BRegister [expr 0x300 + 1] $pulse_width
    WriteR3BRegister [expr 0x300 + 2] $pulse_delay
    WriteR3BRegister [expr 0x300 + 3] $pulse_number
    
    # Start the injection of pulses.
    WriteR3BRegister 0x300 3
    
    # It will wait twice the time required for pulse injection.
    set clock_period 10e-9 ;# [ns]
    set time_total [expr ($pulse_width + $pulse_delay)*$pulse_number*$clock_period];# [ns]
    set time_total [expr round($time_total*1e3*2) +1]; # [ms]
    after $time_total; # [ms]
    
}

proc do_AnalyseSpectra { SIDE ASIC CHANNEL } {
    
    set file_name "E.$SIDE.$ASIC.$CHANNEL"
    # InsertLog "$file_name"
    
    # set SpecNames [SpectrumNames]
    # SpectrumNames is a function of Html/RunControl/sys.tcl 
    # I do not understand how it can be called here.
    # In fact I do not have any include of Html/RunControl/sys.tcl.
    
    set SpecDetails [SpectrumDetails $file_name]
    # SpecDetails has lenght 6.
    # The third element is the range : [0, x-max].
    set range [lindex $SpecDetails 2]
    set data [SpectrumRead1D $file_name 0 $range]
    # InsertLog "Range $range , $data"
    
    # This should zero the histogram.
    ZeroSpectrum $file_name
    
    return [list $range $data] 
}

proc set_ASICValidate { SIDE ASIC n} {
    
    set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1]] ;#  REG1
    set vl [expr ($vl & 0xc0) + ($n << 4)]
    WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1] $vl
    
}

# Histogramming settings.
# index   option
# 01      include (always set to 1)
# 02      DT channels
# 03      DT offset
# 04      DT shift
# 05      E channels
# 06      E offset
# 07      E shift
# 08      group (always set to 1)
# 09-24   histogram enable (side 0)
# 25-40   histogram enable (side 1)
# 41      DT enable
# 42      E enable

proc do_histogramSettings { side type channels offset shift } {
    
    # Dummy variables for side selection.
    variable isSide0 0;
    variable isSide1 0;
    if { $side==0 } {
	set isSide0 1
	set isSide1 0
    } elseif { $side==1 } {
	set isSide0 0
	set isSide1 1
    }
    
    # Dummy variables for type selection.
    variable isE  0;
    variable isDt 0;
    if { $type == "E" } {
	set isE  1
	set isDt 0
    } elseif { $type == "Dt" } {
	set isE  0
	set isDt 1
    }
    
    # Set options 
    foreach key [lsort [array names ::Options] ] {
	
	# Always set these to 1
	if { $key == "Include.R3B" } {
	    set ::Options($key) 1
	} elseif { $key == "R3B_GroupBase" } {
	    set ::Options($key) 1
	}
	
	# DT spectra
	if { $key == "R3B.DTchannels"} {
	    set ::Options($key) [expr $channels*$isDt]
	} elseif { $key == "R3B.DToffset"} {
	    set ::Options($key) [expr $offset*$isDt]
	} elseif { $key == "R3B.DTshift"} {
	    set ::Options($key) [expr $shift*$isDt]
	} elseif { $key == "R3B_Hist_DT_Enable" } {
	    set ::Options($key) $isDt
	}
	
	# Energy spectra
	if { $key == "R3B.channels"} {
	    set ::Options($key) [expr $channels*$isE]
	} elseif { $key == "R3B.offset"} {
	    set ::Options($key) [expr $offset*$isE]
	} elseif { $key == "R3B.shift"} {
	    set ::Options($key) [expr $shift*$isE]
	} elseif { $key == "R3B_Hist_E_Enable" } {
	    set ::Options($key) $isE
	}
	
	# Enable for side 0 (N side)
	if { [string match "R3B_Hist_0.*" $key] } { 
	    set ::Options($key) $isSide0
	}
	
	# Enable for side 1 (P side)
	if { [string match "R3B_Hist_1.*" $key] } { 
	    set ::Options($key) $isSide1
	}
    }
    
    SaveOptions
    
}

# } ;# end of namespace



# This is not usefuf at the moment.
# It may become useful in the future.
# So, I did not delete it, yet.
#
# This reads R3B event counter.
# 41 is Hit items.
# 46 is R3B events.
#
# proc do_counters {} {
# 	global errorCode errorInfo
# 	global DataAcquisitionControlServerHost
# 	global MIDAS_DataAcquisitionControlServer_Exists

# 	if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
# 	    set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetCounters} m]
# 	    set counters $m
# 	} else {
# 	    if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
# 		set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
# 		DataAcquisitionControlClient_Configure
# 	    }
# 	    set rc [catch {DataAcquisitionControlClient__GetCounters} m]
# 	    set counters [second $m]
# 	    if {[first $counters] == 0x10004} \
    # 		{InsertLog "Error reading counters [first $counters]"; set counters ""}
# 	}

# 	set msg ""
# 	if {$rc != 0} {
# 	    InsertLog "COUNTERS returned with an error\n$m\n$errorCode\n$errorInfo"
# 	} else {
# 	    foreach item $counters {append msg "[expr $item] "}
# 	}
# 	return $msg
# }