


#    TDC edge detection and resolution   -    2x opcodes

#    22   set edge detection
#    23   read edge detection
#    24   set LSB of leading/trailing edge
#    25   set pair resolution
#    26   read resolution
#    28   set channel deadtime
#    29   read channel deadtime


     proc do_edopt {p  vl} {

# InsertLog "do_edopt $p $vl"

#  p = 1;   Edge Detection Configuration
#      2;   Set LSB of leading/trailing edge
#      3;   Resolution of leading edge arrival time
#      4;   Resolution of pulse width
#      5;   Set channel dead time

          variable EDOpt$p; set EDOpt$p $vl

          switch $p {
              1   {do_set_opcode 0x2200 $vl}
              2   {do_set_opcode 0x2400 $vl}
              3   {
                 set resolution [do_read_opcode 0x2600]
                 do_set_opcode 0x2500 [expr ($resolution & 0xff00) + $vl]
              }
              4   {
                 set resolution [do_read_opcode 0x2600]
                 do_set_opcode 0x2500 [expr ($resolution & 0xff00)+ ($vl << 8)]
              }
              5 {do_set_opcode 0x2800 $vl}
              default {}
          }

          redisplay_ed
     }

     proc redisplay_ed {} {
         variable EDOpt1
         variable EDOpt2
         variable EDOpt3
         variable EDOpt4
         variable EDOpt5

         set configuration [expr [do_read_opcode 0x2300] & 3]  ;# edge detection configuration
         set EDOpt1 $configuration
         set resolution [do_read_opcode 0x2600]   ;# resolution
         if {$configuration != 0} {
            set EDOpt2 $resolution
         } else {
            set EDOpt3 [expr ($resolution & 0x000f)]
            set EDOpt4 [expr ($resolution & 0xff00) >> 8]
         }
         set EDOpt5 [do_read_opcode 0x2900]   ;# channel dead time

     }






