

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    UpdateModule
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

   variable allchannels 0
   variable allmodules 0

    variable ModuleName v1751psd
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable SoftTrigRun 0
    variable AcqPaused 0

    variable NumChans 8
    variable Name V1751PSD

   set BoardInfo [ReadRegister BoardInfo]
   if {$BoardInfo != 0xdead} {
       set FamilyCode [expr $BoardInfo & 0xff]
       set NumChans [expr ($BoardInfo >> 16) & 0xff]
   }

#    for the Register Menus each item is a list
#      0) name for menu
#      1) register
#      2) file containing support implementation
#      3) Display procedure  (null if none)
#      4) parameter update procedure   (null if none)
#      5) parameter save procedure (null if none)
#      6) parameter restore procedure (null if none)

    variable ModuleRegMenu { \
       {"Configuration"                       Config        Config.tml        GetConfig DrawConfig null null} \
       {"Buffer Organisation"                 BufferOrg     BuffOrg.tml       GetBuffOrg DrawBuffOrg null null} \
       {"Acquisition Window"                  CustomSize    CustSize.tml      GetCustSize DrawCustSize null null} \
       {"Start/Stop Run Delay"                RunDelay      RunDelay.tml      GetRunDelay DrawRunDelay null null} \
       {"Channel Enable Mask"                 Enable        ChEnable.tml      GetChEnable DrawChEnable null null} \
       {"Trigger Source Enable Mask"          TrigSrcEnable TrigSrcEnable.tml GetTrigSrcEnable DrawTrigSrcEnable null null} \
       {"Front Panel Trigger Out Enable Mask" FPTrigOutEnable  FPTrigEnable.tml  GetFPTrigEnable DrawFPTrigEnable null null} \
       {"Front Panel I/O Control"             FPIOControl   FPIOCtrl.tml      GetFPIO DrawFPIO null null} \
       {"External Trigger"               Veto          Veto.tml          GetVeto DrawVeto null null} \
       {"Acquisition Control"                 AcqControl    AcqCtrl.tml       GetAcqCtrl DrawAcqCtrl null null} \
       {"Acquisition Status"                  AcqStatus     AcqStatus.tml     GetAcqStatus DrawAcqStatus null null} \
       {"VME Control"                         VMECtrl       VMECtrl.tml       GetVMECtrl DrawVMECtrl null null} \
       {"VME Status"                          VMEStatus     VMEStatus.tml     GetVMEStatus DrawVMEStatus null null} \
       {"System Options"                      SystemOpts    SystemOpts.tml    GetSystemOpts DrawSystemOpts null null} \
    }

    variable ChRegMenu { \
       {"BaseLine 0x1n64"           BaseLine BaseLine.tml GetBaseLine DrawBaseLine SaveBaseLine RestBaseLine} \
       {"Charge Sensitivity 0x1n80 [2:0]"    Charge Charge.tml GetCharge DrawCharge SaveCharge RestCharge} \
       {"Coincidence Mode 0x1n80 [19:18]"    CoincMode CoincMode.tml GetCoincMode DrawCoincMode SaveCoincMode RestCoincMode} \
       {"Extras 0x1n80 [13:11]"     Extras Extras.tml GetExtras DrawExtras SaveExtras RestExtras} \
       {"DC Offset 0x1n98"             DCOffset  DCOffset.tml GetDCOffset DrawDCOffset SaveDCOffset RestDCOffset} \
       {"Events Per Buffer 0x1n34"     EvtsPerBuf  EvtsPerBuf.tml GetEvtsPerBuf DrawEvtsPerBuf \
                                SaveEvtsPerBuf RestEvtsPerBuf} \
       {"Long Gate 0x1n58"             LongGate  LongGate.tml   GetLongGate DrawLongGate SaveLongGate RestLongGate} \
       {"Pre Gate 0x1n5c"              PreGate  PreGate.tml   GetPreGate DrawPreGate SavePreGate RestPreGate} \
       {"Pre Trigger Window 0x1n38"    PreTrig  PreTrig.tml   GetPreTrig DrawPreTrig SavePreTrig RestPreTrig} \
       {"PSD Threshold 0x1n78"     PSDThreshold PSDThreshold.tml GetPSDThreshold DrawPSDThreshold \
                                SavePSDThreshold RestPSDThreshold} \
       {"CFD Params 0x1n3c"    CFDParams  CFDParams.tml   GetCFDParams DrawCFDParams SaveCFDParams RestCFDParams} \
       {"Base Line Mean 0x1n80 [22:20]" BaseLineMean BaseLineMean.tml GetBaseLineMean DrawBaseLineMean \
                                SaveBaseLineMean RestBaseLineMean} \
       {"Pulse Polarity 0x1n80 [16]"        Polarity Polarity.tml GetPolarity DrawPolarity SavePolarity RestPolarity} \
       {"Short Gate 0x1n54"            ShortGate ShortGate.tml  GetShortGate DrawShortGate SaveShortGate RestShortGate} \
       {"Self Trigger Disable 0x1n80 [24]"  SelfTrig SelfTrig.tml GetSelfTrig DrawSelfTrig SaveSelfTrig RestSelfTrig} \
       {"Trigger Threshold 0x1n60"     Threshold TrigThreshold.tml GetThreshold DrawThreshold \
                                SaveThreshold RestThreshold} \
       {"Trigger Width 0x1n70"     TrigWidth TrigWidth.tml GetTrigWidth DrawTrigWidth SaveTrigWidth RestTrigWidth} \
       {"Trig Val Mask 0x81nm"         TrigValMask  TrigValMask.tml   GetTrigValMask DrawTrigValMask SaveTrigValMask RestTrigValMask} \
   }

#   registers for Save/Restore not handled by above (module registers)
    variable SaveRestoreMenu {Enable Config BufferOrg TrigSrcEnable FPTrigOutEnable FPIOControl AcqControl \
       RecLen EvtsPerBuf BLTEventNum}

    variable ModuleRegItem [lindex $ModuleRegMenu 0]
    variable ModuleReg [lindex $ModuleRegItem 0]

    variable ChRegItem [lindex $ChRegMenu 0]
    variable ChReg [lindex $ChRegItem 0]


#    source all implementation files to load implementation code
  foreach item $ModuleRegMenu  {
     set z [catch {source [file join V1751PSD [lindex $item 2]]} m]
     if {$z != 0} {puts "$m"; continue}
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

  foreach item $ChRegMenu  {
     set z [catch {source [file join V1751PSD [lindex $item 2]]} m]
     if {$z != 0} {puts "$m"; continue}
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }



   proc do_RegisterHelp {W} {
      variable [set W]RegItem

       set f [lindex [set [set W]RegItem] 2]

        set Txtfile [file join V1751PSD [file rootname $f].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc do_ExpertHelp {} {

        set Txtfile [file join V1751PSD Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleName
        variable allchannels
        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable ModuleRegItem
        variable ChRegItem
        variable Rmsg
        variable Wmsg
        variable SoftTrigRun

             InsertLog "ModuleName=$ModuleName; ModuleIndex=$ModuleIndex"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag "
             InsertLog "allchannels=$allchannels; allmodules=$allmodules"
             InsertLog "ModuleReg=$ModuleRegItem"
             InsertLog "ChannelReg=$ChRegItem"
             InsertLog "SoftTrigRun=$SoftTrigRun"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
#           InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
#           InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
   }

   proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_UpdateModuleRegisters {} {
        variable ModuleRegMenu

        foreach item $ModuleRegMenu  {
            set updateproc [lindex $item 3]
            if {$updateproc != "null"} {eval $updateproc}
        }
   }

   proc do_UpdateChannelRegisters {} {
       variable ChRegMenu
       foreach item $ChRegMenu  {
           set updateproc [lindex $item 3]
           if {$updateproc != "null"} {eval $updateproc}
       }
   }

   proc do_SelectModuleRegister {w} {
        variable ModuleReg
        variable ModuleRegItem
        variable ModuleRegMenu

      foreach item $ModuleRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ModuleRegItem $item
             set ModuleReg [lindex $item 1]
         }
      }
   }

   proc do_SelectChannelRegister {w} {
        variable ChReg
        variable ChRegItem
        variable ChRegMenu

      foreach item $ChRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ChRegItem $item
             set ChReg [lindex $item 1]
         }
      }
   }

    proc do_SetModuleRegister {w v} {
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "do_SetModuleRegister: $w = $v"}

        switch -glob $w {
            Config.*        {set $w $v; SetConfig}
            BuffOrg         {set $w $v; SetBuffOrg}
            ChEnableMask*   {set $w $v; SetChEnable}
            FPTrigEnable*   {set $w $v; SetFPTrigEnable}
            TrigSrcEnable*  {set $w $v; SetTrigSrcEnable}
            FPIO*           {set $w $v; SetFPIO}
            RecLen -
            CustSize        {set $w $v; SetCustSize}
            PostTrig        {set $w $v; SetPostTrig}
            RunDelay        {set $w $v; SetRunDelay}
            ExtTrigDisable -
            Veto            {set $w $v; SetVeto}

            ReConfig        {WriteRegister ConfigReload 0; after 1000}
            Reset           {WriteRegister Reset 0; after 1000}

            AcqControl  -
            Clear -
            FlushEvBlk -
            SoftwareSyncReset -
            EvtsPerBuf -
            BLTEventNum -
            BufferOrg -
            SoftTrig        {WriteRegister $w $v}

            AcqCtrl*        {set $w $v; SetAcqCtrl}
            AcqStatus*      {}
            VMECtrl*        {set $w $v; SetVMECtrl}
            VMEStatus*      {}

            default {set $w $v}
        }
   }

    proc do_SetChannelRegister {w i vl} {
        variable allchannels
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "do_SetChannelRegister: Ch$i.$w = $vl"}

        for {set j 0} {$j < 8} {incr j} {
           if {$allchannels == 0 && $j != $i} {continue}
           variable Ch$j.$w; set Ch$j.$w $vl
        }

        switch -glob $w {
            TrigValMask -
            BaseLine -
            CFD_Delay -
            CFD_Fraction -
            Charge -
            CoincMode -
            Polarity -    
            SelfTrig -
            Extras -
            BaseLineMean {
                for {set j 0} {$j < 8} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    WriteRegister Ch$j.$w $vl
                }
            }
            TrigWidth -
            PreTrig {
                for {set j 0} {$j < 8} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    Set$w $j
                }
            }
            default {if {$allchannels == 0} {WriteRegister Ch$i.$w $vl} else {WriteRegister $w $vl}}
       }
   }

   proc do_SoftTrig {n} {

      switch $n {
        1     {WriteRegister SoftTrig 1}
        0     {puts "V1751PSD finished SoftTrig run"; set ::V1751PSD::SoftTrigRun 0}
        100   {set ::V1751PSD::SoftTrigRun 1; after 100 ::V1751PSD::do_SoftTrig 99}
        99999 {puts "V1751PSD starting SoftTrig run"; set ::V1751PSD::SoftTrigRun 1; after 100 ::V1751PSD::do_SoftTrig 99998}
        99998 {if {$::V1751PSD::SoftTrigRun ==0} return; do_WriteSoftTrig; after 100 ::V1751PSD::do_SoftTrig 99998}
        default  {if {$::V1751PSD::SoftTrigRun ==0} return; do_WriteSoftTrig; if {$n > 0} {after 100 ::V1751PSD::do_SoftTrig [expr $n-1]}}
      }
   }

   proc do_WriteSoftTrig {} {
      global errorCode errorInfo
      variable Wmsg

       set r [set ::V1751PSD::ModuleName]#[set ::V1751PSD::ModuleIndex].SoftTrig
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $r 1} Wmsg]
       if {$z != 0} {
           InsertLog "WriteRegister $r failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu

        set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           foreach item $ModuleRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $ChRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $SaveRestoreMenu {

               DBSetValue $item  [ReadRegister $item]
           }
 

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu
        variable allmodules
        variable allchannels

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $allchannels

        set allmodules 0
        set allchannels 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

#        WriteRegister Reset 0   ;# software reset modules

           foreach item $ModuleRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $ChRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $SaveRestoreMenu {

               WriteRegister $item [DBGetValue $item]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set allchannels $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

    proc ReadDataFIFO {} {

        set datafifo [ReadRegister Output_Buffer]
        InsertLog "read data fifo returned: rc = [first $datafifo]; count=[second $datafifo]"

    }

    proc do_Correlation {} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable allchannels

        set SAV1 $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

        InsertLog "Performing coincidence setup check module $ModuleIndex "

#    ITRG  bit 2 in CONFIG register

        set reg [ReadRegister Config]
        set vl  [expr ($reg >> 2) & 1]

        if {$vl == 1} {
             InsertLog "CONFIG register bit EN_ITRG has the value 1 (ITRG enabled)"
        } else {
             WriteRegister Config [expr $reg | 0x00000004]
             InsertLog "CONFIG register bit EN_ITRG has been set to 1"
        }

#    Coincidence enable

        for {set i 0} {$i < 8} {incr i} {
           set reg [ReadRegister Ch$i.DPP_CTRL]
           set vl [expr ($reg >> 18) & 3]

           if {$vl == 1} {
               InsertLog "Ch$i DPP_CTRL register TRG_MODE (bits 19:18) has the value 1 (coincidence enabled)"
           } else {
               WriteRegister Ch$i.DPP_CTRL [expr $reg | 0x00040000]
               InsertLog "Ch$i DPP_CTRL register TRG_MODE (bits 19:18) has been set to 1"
           }
        }

#    trigger request width

        for {set i 0} {$i < 8} {incr i} {
           set reg [ReadRegister Ch$i.TrigWidth]
           set vl [expr $reg * 8]

           if {$vl > 0} {
               InsertLog "Ch$i Trig Request Width register has the value $vl ns"
           } else {
               WriteRegister Ch$i.TrigWidth 1
               InsertLog "Ch$i Trig Request Width register has been set to 8ns"
           }
        }

#    coincidence mask register 

        for {set i 0} {$i < 8} {incr i} {
           set reg [ReadRegister Ch$i.TrigValMask]
           set vl $reg

           if {$vl != 0x20000000} {
               InsertLog "Ch$i Trig Val Mask register has the value $vl"
           } else {
               WriteRegister Ch$i.TrigValMask 0x40000000
               InsertLog "Ch$i Trig Request Width register has been set to 0x40000000 (coincidence between channel and ext trigger)"
           }
        }

        }

        set ModuleIndex $SAV1

    }

    proc do_AcqPause {} {
        variable AcqPaused 

        if {$AcqPaused == 1} {return}

        WriteRegister AcqControl 0

        set AcqPaused 1

    }

    proc do_AcqResume {} {
        variable AcqPaused 

        if {$AcqPaused == 0} {return}

        WriteRegister AcqControl 4

        set AcqPaused 0
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER      {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp Module}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                        Reset -
                        Clear -
                        SoftwareSyncReset -
                        FlushEvBlk -
                        ReConfig  {do_SetModuleRegister [lindex $w 1] 0}
                        SoftTrig  {do_SoftTrig [lindex $w 2]}
                        AcqStart  {source [file join V1751PSD AcqStart.tcl]}
                        AcqHalt   {source [file join V1751PSD AcqHalt.tcl]}
                        DataFIFO    {ReadDataFIFO}
                        Scratch     {WriteRegister Scratch 12345}
                        default   {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   CHREGISTER      {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   MSETTING      {do_SetModuleRegister [lindex $w 1] [lindex $w 2]}
                   MSETTINGS     {do_SetModuleRegister [lindex $cgidata 4] [lindex $cgidata 5]}
 
                   CHSETTING     {do_SetChannelRegister [lindex $w 1] [lindex $w 2] [lindex $w 3]}

                   PLLWRITEFLASH {PLLWriteFlash}
                   PLLREADFLASH  {PLLReadFlash}
                   PLLUPDATEFLASH {PLLUpdateFlash}
                   PLLRELOADFLASH {PLLReloadFlash}

                   PLLCLKENABLE {
                       switch [lindex $w 1] {
                           false {variable ClockDelayEnable; set ClockDelayEnable 0}
                           true  {variable ClockDelayEnable; set ClockDelayEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLOUTENABLE {
                       switch [lindex $w 1] {
                           false {variable OutputClockEnable; set OutputClockEnable 0}
                           true  {variable OutputClockEnable; set OutputClockEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLCLKDELAY   {variable ClockDelay; set ClockDelay [lindex $w 1]; PLLUpdateFlash}
                   
                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   CORRELATION  {do_Correlation}
                   PAUSE        {do_AcqPause}
                   RESUME       {do_AcqResume}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule

    }   ;#  end of do_click

}   ;# end of if {$started == 0}


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


