
#    MIDAS Access Server  for  VHSADC server

package require MIDASDomainHandler       ;#  load default support procedures

set z [catch {package require VHSADC} m]
if {$z != 0} {puts "$m"}

global MIDAS_VHSADCAccessServer_Exists
set MIDAS_VHSADCAccessServer_Exists 1

global MIDAS_SOAPDomainHandler_Verbose
set MIDAS_SOAPDomainHandler_Verbose 0

global MIDAS_VHSADCAccessServer_Verbose
set MIDAS_VHSADCAccessServer_Verbose 0

global MIDAS_VHSADC_MaxBoards 
if {![info exists MIDAS_VHSADC_MaxBoards]} {set MIDAS_VHSADC_MaxBoards 8}



# Use namespaces to isolate your methods
namespace eval urn:VHSADCAccessServer {

set WriteIF 0x70     ;#   User Register 0
set ReadIF 0x74      ;#   User Register 1


    proc SetUpTemp {} {
        global env

        if {![info exists env(MIDASTempDir)] || ![file exists $env(MIDASTempDir)]} then {
           switch $env(os) {
              Win {set env(MIDASTempDir) [file join c:/ temp]}
              default {set env(MIDASTempDir) \tmp}
           }
        }   

        catch {file mkdir $env(MIDASTempDir}
        catch {file mkdir [file join $env(MIDASTempDir) VHSADCAccessServer]}
    }

    proc VHSADCVerbose {vl} {
        global MIDAS_VHSADCAccessServer_Verbose MIDAS_SOAPDomainHandler_Verbose

        set MIDAS_VHSADCAccessServer_Verbose $vl
        set MIDAS_SOAPDomainHandler_Verbose $vl

        return [rpcvar::rpcvar int 0]
    }

    proc VHSADCInit {} {
        global MIDAS_VHSADCAccessServer_Verbose
        global MIDAS_VHSADC_MaxBoards

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADCInit"}

        set rc [VHSADC_Init]
        if {$rc > $MIDAS_VHSADC_MaxBoards} {set rc $MIDAS_VHSADC_MaxBoards}
        SetUpTemp

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCUpLoad {file contents} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_UpLoad"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $file].base64]

        set z [catch {open $path w} f]
        if {$z != 0} then {error "Cannot create/open file $path in VHSADCUpLoad\n$f"}

        puts $f $contents
        close $f

        set f [file join $env(MIDASTempDir) VHSADCServer [file tail $file]]

        set z [catch {exec base64 --decode $path $f} m]
        if {$z != 0} then {error "Error in base64 decoding $path in VHSADCUpLoad\n$m"}

        set rc 0

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetAcquisitionStatus {id status} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetAcquisitionStatus"}

        set rc [VHSADC_SetAcquisitionStatus $id $status]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCGetFPGARevision {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_GetFPGARevision"}

        set rc [VHSADC_GetFPGARevision $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetLed {id number type state} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetLed"}

        set rc [VHSADC_SetLed $id $number $type $state]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetAcquisitionCLK {id source} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetAcquisitionCLK"}

        set rc [VHSADC_SetAcquisitionCLK $id $source]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetTriggerOption {id mode} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetTriggerOption"}

        set rc [VHSADC_SetTriggerOption $id $mode]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetGainEnableMode {id channel} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetGainEnableMode"}

        set rc [VHSADC_SetGainEnableMode $id $channel]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetGainLevel {id ctrl level} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetGainLevel"}

        set rc [VHSADC_SetGainLevel $id $ctrl $level]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCGetGainLevelReg {id level} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_GetGainLevelReg"}

        set rc [VHSADC_GetGainLevelReg $id $level]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetGainMode {id channel} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetGainMode"}

        set rc [VHSADC_SetGainMode $id $channel]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCSetUserCtrlReg {id number value} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_SetUserCtrlReg"}

        set rc [VHSADC_SetUserCtrlReg $id $number $value]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCGetUserCtrlReg {id number} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_GetUserCtrlReg"}

        set rc [VHSADC_GetUserCtrlReg $id $number]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16FpgaReset {id bitstream len} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FpgaReset"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $bitstream]]

        set rc [Vhsadac16_FpgaReset $id $path $len]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16FpgaLoad {id bitstream} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FpgaLoad"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $bitstream]]

        set rc [Vhsadac16_FpgaLoad $id $path]

        after 2000   ;#  delay helps prevent Windows freeze 

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16FlashProgram {id bitstream} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FlashProgram"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $bitstream]]

        set rc [Vhsadac16_FlashProgram $id $path]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16FlashErase {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FlashErase"}

        set rc [Vhsadac16_FlashErase $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16FlashBoot {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FlashBoot"}

        set rc [Vhsadac16_FlashBoot $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }


    proc Vhsadac16ReadFpgaReg {id register} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_ReadFpgaReg"}

        set rc [Vhsadac16_ReadFpgaReg $id $register]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16ReadFpgaRegs {id registers} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_ReadFpgaRegs"}

        set rc {}
        foreach register $registers {
            lappend rc [Vhsadac16_ReadFpgaReg $id $register]
        }

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int() $rc]
    }

    proc VHSADCAccessClientReadUserRegs {id registers} {
        global MIDAS_VHSADCAccessServer_Verbose
        upvar ReadIF ReadIF

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADCAccessClientReadUserRegs"}

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 1} msg]
        after 10

        set rc {}
        foreach register $registers {

            Vhsadac16_WriteFpgaReg $id $ReadIF $register        ;#    write to user register
            Vhsadac16_WriteFpgaReg $id $ReadIF $register        ;#    write to user register
            lappend rc [Vhsadac16_ReadFpgaReg $id $ReadIF]  ;# user register
        }

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 0} msg]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int() $rc]
    }

    proc Vhsadac16WriteFpgaReg {id register value} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_WriteFpgaReg"}

        set rc [Vhsadac16_WriteFpgaReg $id $register $value]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16WriteFpgaRegs {id arg} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_WriteFpgaRegs"}

        foreach item $arg {
          set rc [Vhsadac16_WriteFpgaReg $id [first $item] [second $item]]
#          if {$rc != 0} {break}
        }

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCAccessClientWriteUserRegs {id registers} {
        global MIDAS_VHSADCAccessServer_Verbose
        upvar WriteIF WriteIF

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADCAccessClientWriteUserRegs"}

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 1} msg]
        after 10

        foreach register $registers {
            set rc [Vhsadac16_WriteFpgaReg $id $WriteIF $register]
#            if {$rc != 0} {break}
        }

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 0} msg]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16WriteFpgaMem {id offset len data} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_WriteFpgaMem"}

        set rc [Vhsadac16_WriteFpgaMem $id $offset $len $data]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16ReadFpgaMem {id offset len} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_ReadFpgaMem"}

        set rc [Vhsadac16_ReadFpgaMem $id $offset $len]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar string $rc]
    }

    proc Vhsadac16GetCpldRegs {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_GetCpldRegs"}

        set rc [Vhsadac16_GetCpldRegs $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar string $rc]
    }

    proc Vhsadac16Clock_Frequency {id freq} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_Clock_Frequency"}

        set rc [Vhsadac16_Clock_Frequency $id $freq]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc VHSADCExit {} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::ServerExit"}

   set rc 0
             
        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int 0]
    }


    # We have to publish the public methods...

     SOAP::export VHSADCVerbose
     SOAP::export VHSADCInit

     SOAP::export VHSADCUpLoad

     SOAP::export VHSADCSetAcquisitionStatus
     SOAP::export VHSADCGetFPGARevision
     SOAP::export VHSADCSetLed
     SOAP::export VHSADCSetAcquisitionCLK
     SOAP::export VHSADCSetTriggerOption
     SOAP::export VHSADCSetGainEnableMode
     SOAP::export VHSADCSetGainLevel
     SOAP::export VHSADCGetGainLevelReg
     SOAP::export VHSADCSetGainMode
     SOAP::export VHSADCSetUserCtrlReg
     SOAP::export VHSADCGetUserCtrlReg

     SOAP::export Vhsadac16FpgaReset
     SOAP::export Vhsadac16FpgaLoad

     SOAP::export Vhsadac16FlashProgram
     SOAP::export Vhsadac16FlashErase
     SOAP::export Vhsadac16FlashBoot

     SOAP::export Vhsadac16ReadFpgaReg
     SOAP::export Vhsadac16WriteFpgaReg

     SOAP::export Vhsadac16ReadFpgaRegs
     SOAP::export Vhsadac16WriteFpgaRegs

     SOAP::export VHSADCAccessClientReadUserRegs
     SOAP::export VHSADCAccessClientWriteUserRegs

     SOAP::export Vhsadac16ReadFpgaMem
     SOAP::export Vhsadac16WriteFpgaMem

     SOAP::export Vhsadac16GetCpldRegs
     SOAP::export Vhsadac16Clock_Frequency

     SOAP::export VHSADCExit
     
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /VHSADCAccessServer -namespace urn:VHSADCAccessServer -uri urn:VHSADCAccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/VHSADCAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide VHSADCAccessServer 1.0

set msg "$rc Web Service Installed\n"

   if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown"} else {
       ::DefineMessage -c vhsadc -l INFORMATION  "$msg"}
